/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __CDOS_KEY_GRABBER_H__
#define __CDOS_KEY_GRABBER_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for org.freedesktop.KeyGrabber */

#define CDOS_TYPE_KEY_GRABBER (cdos_key_grabber_get_type ())
#define CDOS_KEY_GRABBER(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), CDOS_TYPE_KEY_GRABBER, CdosKeyGrabber))
#define CDOS_IS_KEY_GRABBER(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), CDOS_TYPE_KEY_GRABBER))
#define CDOS_KEY_GRABBER_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), CDOS_TYPE_KEY_GRABBER, CdosKeyGrabberIface))

struct _CdosKeyGrabber;
typedef struct _CdosKeyGrabber CdosKeyGrabber;
typedef struct _CdosKeyGrabberIface CdosKeyGrabberIface;

struct _CdosKeyGrabberIface
{
  GTypeInterface parent_iface;


  gboolean (*handle_grab_accelerator) (
    CdosKeyGrabber *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_accelerator,
    guint arg_modeFlags,
    guint arg_grabFlags);

  gboolean (*handle_grab_accelerators) (
    CdosKeyGrabber *object,
    GDBusMethodInvocation *invocation,
    GVariant *arg_accelerator);

  gboolean (*handle_ungrab_accelerator) (
    CdosKeyGrabber *object,
    GDBusMethodInvocation *invocation,
    guint arg_action);

  gboolean (*handle_ungrab_accelerators) (
    CdosKeyGrabber *object,
    GDBusMethodInvocation *invocation,
    GVariant *arg_action);

  void (*accelerator_activated) (
    CdosKeyGrabber *object,
    guint arg_action,
    guint arg_timestamp,
    const gchar *arg_deviceNode);

};

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CdosKeyGrabber, g_object_unref)
#endif

GType cdos_key_grabber_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *cdos_key_grabber_interface_info (void);
guint cdos_key_grabber_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void cdos_key_grabber_complete_grab_accelerator (
    CdosKeyGrabber *object,
    GDBusMethodInvocation *invocation,
    guint action);

void cdos_key_grabber_complete_grab_accelerators (
    CdosKeyGrabber *object,
    GDBusMethodInvocation *invocation,
    GVariant *action);

void cdos_key_grabber_complete_ungrab_accelerator (
    CdosKeyGrabber *object,
    GDBusMethodInvocation *invocation,
    gboolean success);

void cdos_key_grabber_complete_ungrab_accelerators (
    CdosKeyGrabber *object,
    GDBusMethodInvocation *invocation,
    gboolean success);



/* D-Bus signal emissions functions: */
void cdos_key_grabber_emit_accelerator_activated (
    CdosKeyGrabber *object,
    guint arg_action,
    guint arg_timestamp,
    const gchar *arg_deviceNode);



/* D-Bus method calls: */
void cdos_key_grabber_call_grab_accelerator (
    CdosKeyGrabber *proxy,
    const gchar *arg_accelerator,
    guint arg_modeFlags,
    guint arg_grabFlags,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean cdos_key_grabber_call_grab_accelerator_finish (
    CdosKeyGrabber *proxy,
    guint *out_action,
    GAsyncResult *res,
    GError **error);

gboolean cdos_key_grabber_call_grab_accelerator_sync (
    CdosKeyGrabber *proxy,
    const gchar *arg_accelerator,
    guint arg_modeFlags,
    guint arg_grabFlags,
    guint *out_action,
    GCancellable *cancellable,
    GError **error);

void cdos_key_grabber_call_grab_accelerators (
    CdosKeyGrabber *proxy,
    GVariant *arg_accelerator,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean cdos_key_grabber_call_grab_accelerators_finish (
    CdosKeyGrabber *proxy,
    GVariant **out_action,
    GAsyncResult *res,
    GError **error);

gboolean cdos_key_grabber_call_grab_accelerators_sync (
    CdosKeyGrabber *proxy,
    GVariant *arg_accelerator,
    GVariant **out_action,
    GCancellable *cancellable,
    GError **error);

void cdos_key_grabber_call_ungrab_accelerator (
    CdosKeyGrabber *proxy,
    guint arg_action,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean cdos_key_grabber_call_ungrab_accelerator_finish (
    CdosKeyGrabber *proxy,
    gboolean *out_success,
    GAsyncResult *res,
    GError **error);

gboolean cdos_key_grabber_call_ungrab_accelerator_sync (
    CdosKeyGrabber *proxy,
    guint arg_action,
    gboolean *out_success,
    GCancellable *cancellable,
    GError **error);

void cdos_key_grabber_call_ungrab_accelerators (
    CdosKeyGrabber *proxy,
    GVariant *arg_action,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean cdos_key_grabber_call_ungrab_accelerators_finish (
    CdosKeyGrabber *proxy,
    gboolean *out_success,
    GAsyncResult *res,
    GError **error);

gboolean cdos_key_grabber_call_ungrab_accelerators_sync (
    CdosKeyGrabber *proxy,
    GVariant *arg_action,
    gboolean *out_success,
    GCancellable *cancellable,
    GError **error);



/* ---- */

#define CDOS_TYPE_KEY_GRABBER_PROXY (cdos_key_grabber_proxy_get_type ())
#define CDOS_KEY_GRABBER_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), CDOS_TYPE_KEY_GRABBER_PROXY, CdosKeyGrabberProxy))
#define CDOS_KEY_GRABBER_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), CDOS_TYPE_KEY_GRABBER_PROXY, CdosKeyGrabberProxyClass))
#define CDOS_KEY_GRABBER_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), CDOS_TYPE_KEY_GRABBER_PROXY, CdosKeyGrabberProxyClass))
#define CDOS_IS_KEY_GRABBER_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), CDOS_TYPE_KEY_GRABBER_PROXY))
#define CDOS_IS_KEY_GRABBER_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), CDOS_TYPE_KEY_GRABBER_PROXY))

typedef struct _CdosKeyGrabberProxy CdosKeyGrabberProxy;
typedef struct _CdosKeyGrabberProxyClass CdosKeyGrabberProxyClass;
typedef struct _CdosKeyGrabberProxyPrivate CdosKeyGrabberProxyPrivate;

struct _CdosKeyGrabberProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  CdosKeyGrabberProxyPrivate *priv;
};

struct _CdosKeyGrabberProxyClass
{
  GDBusProxyClass parent_class;
};

GType cdos_key_grabber_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CdosKeyGrabberProxy, g_object_unref)
#endif

void cdos_key_grabber_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
CdosKeyGrabber *cdos_key_grabber_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
CdosKeyGrabber *cdos_key_grabber_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void cdos_key_grabber_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
CdosKeyGrabber *cdos_key_grabber_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
CdosKeyGrabber *cdos_key_grabber_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define CDOS_TYPE_KEY_GRABBER_SKELETON (cdos_key_grabber_skeleton_get_type ())
#define CDOS_KEY_GRABBER_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), CDOS_TYPE_KEY_GRABBER_SKELETON, CdosKeyGrabberSkeleton))
#define CDOS_KEY_GRABBER_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), CDOS_TYPE_KEY_GRABBER_SKELETON, CdosKeyGrabberSkeletonClass))
#define CDOS_KEY_GRABBER_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), CDOS_TYPE_KEY_GRABBER_SKELETON, CdosKeyGrabberSkeletonClass))
#define CDOS_IS_KEY_GRABBER_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), CDOS_TYPE_KEY_GRABBER_SKELETON))
#define CDOS_IS_KEY_GRABBER_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), CDOS_TYPE_KEY_GRABBER_SKELETON))

typedef struct _CdosKeyGrabberSkeleton CdosKeyGrabberSkeleton;
typedef struct _CdosKeyGrabberSkeletonClass CdosKeyGrabberSkeletonClass;
typedef struct _CdosKeyGrabberSkeletonPrivate CdosKeyGrabberSkeletonPrivate;

struct _CdosKeyGrabberSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  CdosKeyGrabberSkeletonPrivate *priv;
};

struct _CdosKeyGrabberSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType cdos_key_grabber_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CdosKeyGrabberSkeleton, g_object_unref)
#endif

CdosKeyGrabber *cdos_key_grabber_skeleton_new (void);


G_END_DECLS

#endif /* __CDOS_KEY_GRABBER_H__ */
