#ifndef __APPLET_CALENDAR_ITEM_H__
#define __APPLET_CALENDAR_ITEM_H__

#include "st.h"

G_BEGIN_DECLS

#define APPLET_TYPE_CALENDAR_ITEM                (applet_calendar_item_get_type ())
#define APPLET_CALENDAR_ITEM(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_CALENDAR_ITEM, AppletCalendarItem))
#define APPLET_IS_CALENDAR_ITEM(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_CALENDAR_ITEM))
#define APPLET_CALENDAR_ITEM_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_CALENDAR_ITEM, AppletCalendarItemClass))
#define APPLET_IS_CALENDAR_ITEM_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_CALENDAR_ITEM))
#define APPLET_CALENDAR_ITEM_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_CALENDAR_ITEM, AppletCalendarItemClass))

typedef struct _AppletCalendarItemPrivate AppletCalendarItemPrivate;

/**
 * AppletCalendarItem:
 *
 * AppletCalendarItem结构体的内容是私有的，只能通过公共API访问。
 */
typedef struct _AppletCalendarItem
{
    StWidget parent;

    AppletCalendarItemPrivate *priv;
} AppletCalendarItem;

typedef struct _AppletCalendarItemClass
{
    StWidgetClass parent_class;
} AppletCalendarItemClass;

typedef enum {
    OPT_INVALID = -1,
    OPT_DAY = 0,
    OPT_DAY_WITH_LUNAR,
    OPT_MONTH,
    OPT_YEAR
} CalendarItemOption;

GType applet_calendar_item_get_type (void) G_GNUC_CONST;

StWidget *applet_calendar_item_new_with_label_month (const gchar *text, int month);
StWidget *applet_calendar_item_new_with_label_year (const gchar *text, int year);
StWidget *applet_calendar_item_new_with_label_day_of_month (const gchar *text, int day_of_month);
StWidget *applet_calendar_item_new_with_label_day_and_lunar (const gchar *text, int day_of_month, const gchar *lunar);

CalendarItemOption applet_calendar_item_get_option (AppletCalendarItem *item);
int applet_calendar_item_get_item_data (AppletCalendarItem *item);

G_END_DECLS

#endif // __APPLET_CALENDAR_ITEM_H__
