#ifndef __APPLET_CALENDAR_H__
#define __APPLET_CALENDAR_H__

#include "st.h"

G_BEGIN_DECLS

#define APPLET_TYPE_CALENDAR                (applet_calendar_get_type ())
#define APPLET_CALENDAR(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_CALENDAR, AppletCalendar))
#define APPLET_IS_CALENDAR(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_CALENDAR))
#define APPLET_CALENDAR_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_CALENDAR, AppletCalendarClass))
#define APPLET_IS_CALENDAR_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_CALENDAR))
#define APPLET_CALENDAR_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_CALENDAR, AppletCalendarClass))

typedef struct _AppletCalendarPrivate AppletCalendarPrivate;

/**
 * AppletCalendar:
 *
 * AppletCalendar结构体的内容是私有的，只能通过公共API访问。
 */
typedef struct _AppletCalendar
{
    GObject parent;

    StWidget *actor;
    AppletCalendarPrivate *priv;
} AppletCalendar;

typedef struct _AppletCalendarClass
{
    GObjectClass parent_class;

    /* Signal handlers */
    void (*month_changed) (AppletCalendar *calendar);
    void (*day_selected) (AppletCalendar *calendar);
    void (*day_selected_double_click) (AppletCalendar *calendar);
    void (*prev_month) (AppletCalendar *calendar);
    void (*next_month) (AppletCalendar *calendar);
} AppletCalendarClass;

GType applet_calendar_get_type (void) G_GNUC_CONST;

AppletCalendar *applet_calendar_new (void);

void applet_calendar_update (AppletCalendar *self);

G_END_DECLS

#endif // __APPLET_CALENDAR_H__
