/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *
 * This software is published by the license of CPU-OS License，you can use and
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us
 * by email <support_os@cpu-os.ac.cn>
 *
 **/
//
// Created by zhangtao on 18-1-25.
// Email: zhangtao@cpu-os.ac.cn
//

#ifndef __APPLET_APPLICATION_BUTTON_H__
#define __APPLET_APPLICATION_BUTTON_H__

#include "applet-menu-button-base.h"
#include "cdos-app.h"
#include "cdos-popup-menu.h"


#define APPLET_TYPE_APPLICATION_BUTTON (applet_application_button_get_type())
#define APPLET_APPLICATION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_APPLICATION_BUTTON, AppletApplicationButton))
#define APPLET_IS_APPLICATION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_APPLICATION_BUTTON))
#define APPLET_APPLICATION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_APPLICATION_BUTTON,AppletApplicationButtonClass))
#define APPLET_IS_APPLICATION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_APPLICATION_BUTTON))
#define APPLET_APPLICATION_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), APPLET_TYPE_APPLICATION_BUTTON,AppletApplicationButtonClass))

typedef struct _AppletApplicationButton AppletApplicationButton;
typedef struct _AppletApplicationButtonPrivate AppletApplicationButtonPrivate;
typedef struct _AppletApplicationButtonClass AppletApplicationButtonClass;

struct _AppletApplicationButton
{
    AppletMenuButtonBase parent;
    AppletApplicationButtonPrivate *priv;
};
struct _AppletApplicationButtonClass
{
    AppletMenuButtonBaseClass parent_class;
};

GType	applet_application_button_get_type (void);

AppletApplicationButton*
applet_application_button_new (CdosApp *app, gint icon_size);
void
applet_application_button_set_draggable (AppletApplicationButton *self, gboolean is_draggable);
gboolean
applet_application_button_get_draggable (AppletApplicationButton *self);
CdosApp*
applet_application_button_get_app (AppletApplicationButton *self);
void
applet_application_button_set_context_menu_enable (AppletApplicationButton *self, gboolean enable);
gboolean
applet_application_button_get_context_menu_enable (AppletApplicationButton *self);
CdosPopupMenu *
applet_application_button_get_context_menu (AppletApplicationButton *self);
void
applet_application_button_set_can_drop (AppletApplicationButton *self, gboolean can_drop);
gboolean
applet_application_button_get_can_drop (AppletApplicationButton *self);
ClutterDropAction *
applet_application_button_get_drop_action (AppletApplicationButton *self);
ClutterDragAction *
applet_application_button_get_drag_action (AppletApplicationButton *self);

void
applet_application_button_add_context_menu_item (AppletApplicationButton *self, const gchar *text, gint index,  GCallback  activate_callback,  gpointer user_data);

#endif //__APPLET_APPLICATION_BUTTON_H__
