/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
//
// Created by zhangtao on 18-1-18.
// Email: zhangtao@cpu-os.ac.cn
//

#ifndef __APPLET_APPLICATIONS_MANAGER_H__
#define __APPLET_APPLICATIONS_MANAGER_H__

#include <glib-object.h>
#include "st.h"
#include "applet-menu-types.h"

#define APPLET_TYPE_APPLICATIONS_MANAGER (applet_applications_manager_get_type())
#define APPLET_APPLICATIONS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_APPLICATIONS_MANAGER,AppletApplicationsManager))
#define APPLET_IS_APPLICATIONS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_APPLICATIONS_MANAGER))
#define APPLET_APPLICATIONS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_APPLICATIONS_MANAGER,AppletApplicationsManagerClass))
#define APPLET_IS_APPLICATIONS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_APPLICATIONS_MANAGER))
#define APPLET_APPLICATIONS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_APPLICATIONS_MANAGER,AppletApplicationsManagerClass))

typedef struct _AppletApplicationsManager AppletApplicationsManager;
typedef struct _AppletApplicationsManagerPrivate AppletApplicationsManagerPrivate;
typedef struct _AppletApplicationsManagerClass AppletApplicationsManagerClass;

struct _AppletApplicationsManager
{
    GObject parent;
    AppletApplicationsManagerPrivate *priv;
};

struct _AppletApplicationsManagerClass
{
    GObjectClass parent_class;
};

GType	applet_applications_manager_get_type (void);

AppletApplicationsManager* 
applet_applications_manager_new (void);
void
applet_applications_manager_set_group_type (AppletApplicationsManager *self, 
                                            ApplicationsGroupType group_type);
ApplicationsGroupType
applet_applications_manager_get_group_type (AppletApplicationsManager *self);
void
applet_applications_manager_set_expand_button_visible (AppletApplicationsManager *self, gboolean show);

StBoxLayout *
applet_applications_manager_get_box (AppletApplicationsManager *self);
void
applet_applications_manager_start_key_focus (AppletApplicationsManager *self);
void
applet_application_mananger_set_frequently_used_visible (AppletApplicationsManager *self, gboolean show);
gboolean 
applet_application_manager_get_is_scrolling (AppletApplicationsManager *self);

#endif //__APPLET_APPLICATIONS_MANAGER_H__
