/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *
 * This software is published by the license of CPU-OS License，you can use and
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us
 * by email <support_os@cpu-os.ac.cn>
 *
 **/
//
// Created by zhangtao on 18-1-18.
// Email: zhangtao@cpu-os.ac.cn
//

#ifndef __APPLET_APPLICATIONS_H__
#define __APPLET_APPLICATIONS_H__

#include <glib.h>
#include <glib-object.h>
#include "applet-menu-types.h"

#define APPLET_TYPE_APPLICATIONS (applet_applications_get_type ())
#define APPLET_APPLICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_APPLICATIONS, AppletApplications))
#define APPLET_IS_APPLICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_APPLICATIONS))
#define APPLET_APPLICATIONS_CLASS(klass)                                                                               \
    (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_APPLICATIONS, AppletApplicationsClass))
#define APPLET_IS_APPLICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((obj), APPLET_TYPE_APPLICATIONS))
#define APPLET_APPLICATIONS_GET_CLASS(obj)                                                                             \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_APPLICATIONS, AppletApplicationsClass))

typedef struct _AppletApplications AppletApplications;
typedef struct _AppletApplicationsPrivate AppletApplicationsPrivate;
typedef struct _AppletApplicationsClass AppletApplicationsClass;

struct _AppletApplications
{
    GObject parent;
    AppletApplicationsPrivate *priv;
};
struct _AppletApplicationsClass
{
    GObjectClass parent_class;
};

GType applet_applications_get_type (void);

AppletApplications *
applet_applications_get_default (void);
GList *
applet_applications_get_by_letter (AppletApplications *self, const gchar *letter);
GList *
applet_applications_get_by_category (AppletApplications *self, const gchar *category);
gchar *
applet_applications_get_category_icon_name (AppletApplications *self, const gchar *category);
GList *
applet_applications_get_groups (AppletApplications *self, ApplicationsGroupType group_type);
GList *
applet_applications_search (AppletApplications *self, const gchar *keyword);

#endif //__APPLET_APPLICATIONS_H__
