/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
//
// Created by zhangtao on 18-1-25.
// Email: zhangtao@cpu-os.ac.cn
//

#ifndef __APPLET_CATEGORY_BASE_H__
#define __APPLET_CATEGORY_BASE_H__

#include "st.h"
#include "cdos-app.h"
#include "applet-menu-types.h"

#define APPLET_TYPE_CATEGORY_BASE (applet_category_base_get_type())
#define APPLET_CATEGORY_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_CATEGORY_BASE,AppletCategoryBase))
#define APPLET_IS_CATEGORY_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_CATEGORY_BASE))
#define APPLET_CATEGORY_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_CATEGORY_BASE,AppletCategoryBaseClass))
#define APPLET_IS_CATEGORY_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_CATEGORY_BASE))
#define APPLET_CATEGORY_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_CATEGORY_BASE,AppletCategoryBaseClass))

typedef struct _AppletCategoryBase AppletCategoryBase;
typedef struct _AppletCategoryBasePrivate AppletCategoryBasePrivate;
typedef struct _AppletCategoryBaseClass AppletCategoryBaseClass;

struct _AppletCategoryBase
{
    StBoxLayout parent;
    AppletCategoryBasePrivate *priv;
};
struct _AppletCategoryBaseClass
{
    StBoxLayoutClass parent_class;
    void    (*title_changed) (AppletCategoryBase *self, const gchar *new_title);
};

GType	applet_category_base_get_type (void);

void 
applet_category_base_set_name (AppletCategoryBase *self, const gchar *name);
const gchar* 
applet_category_base_get_name (AppletCategoryBase *self);
void 
applet_category_base_set_title (AppletCategoryBase *self, const gchar *title);
const gchar* 
applet_category_base_get_title (AppletCategoryBase *self);
void 
applet_category_base_set_icon_name (AppletCategoryBase *self, const gchar *icon_name);
void 
applet_category_base_show_expand_button (AppletCategoryBase *self, gboolean is_show);
void 
applet_category_base_set_can_delete (AppletCategoryBase *self, gboolean can_delete);
void 
applet_category_base_set_default_show_num (AppletCategoryBase *self, gint show_num);
gint 
applet_category_base_get_default_show_num (AppletCategoryBase *self);
void 
applet_category_base_set_default_column_num (AppletCategoryBase *self, gint show_num);
gint
applet_category_base_get_default_column_num (AppletCategoryBase *self);
void 
applet_category_base_set_can_edit_title (AppletCategoryBase *self, gboolean can_edit);
gboolean 
applet_category_base_get_can_edit_title (AppletCategoryBase *self);
void
applet_category_base_set_source_data (AppletCategoryBase *self, GList *source_data);
GList *
applet_category_base_get_source_data (AppletCategoryBase *self);
void
applet_category_base_source_data_changed (AppletCategoryBase *self, GList *new_source_data, gboolean free);
void
applet_category_base_set_app_button_can_drop (AppletCategoryBase *self, gboolean can_drop);
gboolean
applet_category_base_get_app_button_can_drop (AppletCategoryBase *self);
GList *
applet_category_base_get_app_buttons (AppletCategoryBase *self);
void
applet_category_base_buttons_navigate_focus (AppletCategoryBase *self, gint index);
void
applet_category_base_show_button_preview_holder (AppletCategoryBase *self, ClutterActor *before_button);
void
applet_category_base_hide_button_preview_holder (AppletCategoryBase *self);
gboolean
applet_category_base_is_accept_button_drop (AppletCategoryBase *self, gfloat x, gfloat y);
void 
applet_category_base_switch_expand_button (AppletCategoryBase *self);
gboolean
applet_category_base_get_expand (AppletCategoryBase *self);
void
applet_category_base_set_expand (AppletCategoryBase *self, gboolean expand);
void
applet_category_base_close_all_popup_menu (AppletCategoryBase *self);
void
applet_category_base_set_button_layout_mode (AppletCategoryBase *self, AppletButtonLayoutMode mode);
void
applet_category_base_set_head_sensitive (AppletCategoryBase *self, gboolean sensitive);
gboolean
applet_category_base_get_head_sensitive (AppletCategoryBase *self);

#endif //__APPLET_CATEGORY_BASE_H__
