/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
//
// Created by zhangtao on 18-1-18.
// Email: zhangtao@cpu-os.ac.cn
//

#ifndef __APPLET_MENU_BUTTON_BASE_H__
#define __APPLET_MENU_BUTTON_BASE_H__

#include "st.h"
#include "applet-menu-types.h"

#define APPLET_TYPE_MENU_BUTTON_BASE (applet_menu_button_base_get_type())
#define APPLET_MENU_BUTTON_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_MENU_BUTTON_BASE,AppletMenuButtonBase))
#define APPLET_IS_MENU_BUTTON_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_MENU_BUTTON_BASE))
#define APPLET_MENU_BUTTON_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_MENU_BUTTON_BASE,AppletMenuButtonBaseClass))
#define APPLET_IS_MENU_BUTTON_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_MENU_BUTTON_BASE))
#define APPLET_MENU_BUTTON_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_MENU_BUTTON_BASE,AppletMenuButtonBaseClass))

typedef struct _AppletMenuButtonBase AppletMenuButtonBase;
typedef struct _AppletMenuButtonBasePrivate AppletMenuButtonBasePrivate;
typedef struct _AppletMenuButtonBaseClass AppletMenuButtonBaseClass;

struct _AppletMenuButtonBase
{
    StBoxLayout parent;
    AppletMenuButtonBasePrivate *priv;
};
struct _AppletMenuButtonBaseClass
{
    StBoxLayoutClass parent_class;
    void (*activate) (AppletMenuButtonBase *button_base);
    void (*cancel) (AppletMenuButtonBase *button_base);
};

GType	applet_menu_button_base_get_type (void);

void
applet_menu_button_base_set_icon_by_name (AppletMenuButtonBase *self, const gchar *icon_name);
void
applet_menu_button_base_set_label_text (AppletMenuButtonBase *self, const gchar *text);
void
applet_menu_button_base_set_layout_mode (AppletMenuButtonBase *self, AppletButtonLayoutMode mode);
AppletButtonLayoutMode 
applet_menu_button_base_get_layout_mode (AppletMenuButtonBase *self);
void
applet_menu_button_base_set_sensitive (AppletMenuButtonBase *self, gboolean sensitive);
gboolean
applet_menu_button_base_get_sensitive (AppletMenuButtonBase *self);
void
applet_menu_button_base_set_icon (AppletMenuButtonBase *self, ClutterActor *icon);
ClutterActor *
applet_menu_button_base_get_icon (AppletMenuButtonBase *self);
StWidget *
applet_menu_button_base_get_label (AppletMenuButtonBase *self);
void
applet_menu_button_base_set_icon_size (AppletMenuButtonBase *self, gint icon_size);
gint 
applet_menu_button_base_get_icon_size (AppletMenuButtonBase *self);
void
applet_menu_button_base_set_tooltip (AppletMenuButtonBase *self, const gchar *text);
const gchar *
applet_menu_button_base_get_tooltip (AppletMenuButtonBase *self);
void
applet_menu_button_base_set_tooltip_state (AppletMenuButtonBase *self, gboolean enabled);
void
applet_menu_button_base_activate (AppletMenuButtonBase *self);


#endif //__APPLET_MENU_BUTTON_BASE_H__
