/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
//
// Created by zhangtao on 18-1-18.
// Email: zhangtao@cpu-os.ac.cn
//

#ifndef __APPLET_MENU_H__
#define __APPLET_MENU_H__

#include "cdos-icon-applet.h"
#include "applet-menu-types.h"

#define APPLET_TYPE_MENU (applet_menu_get_type ())
#define APPLET_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), APPLET_TYPE_MENU, AppletMenu))
#define APPLET_IS_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), APPLET_TYPE_MENU))
#define APPLET_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), APPLET_TYPE_MENU, AppletMenuClass))
#define APPLET_IS_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_MENU))
#define APPLET_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), APPLET_TYPE_MENU, AppletMenuClass))

typedef struct _AppletMenu AppletMenu;
typedef struct _AppletMenuPrivate AppletMenuPrivate;
typedef struct _AppletMenuClass AppletMenuClass;

struct _AppletMenu
{
    CdosIconApplet parent;
    AppletMenuPrivate *priv;
};
struct _AppletMenuClass
{
    CdosIconAppletClass parent_class;
};

GType	applet_menu_get_type (void);

CdosApplet *
applets_menu_main (MetaData *metadata, StSide orientation, gfloat panel_height);

StBoxLayout*
applet_menu_get_main_box (void); 
AppletMenu* 
applet_menu_menu_get_default (void);
void 
applet_menu_close (void);
void 
applet_menu_can_close (gboolean can_close);
CdosPopupMenuManager *
applet_menu_get_popup_menu_manager (void);
MenuPane 
applet_menu_get_current_pane (void);
void 
applet_menu_grab_key_focus_main_box (void);

#endif //__APPLET_MENU_H__
