/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
//
// Created by zhangtao on 18-1-18.
// Email: zhangtao@cpu-os.ac.cn
//

#ifndef __APPLET_SHORTCUT_BUTTON_H__
#define __APPLET_SHORTCUT_BUTTON_H__

#include "applet-menu-button-base.h"
#include "cdos-popup-menu.h"

#define APPLET_TYPE_SHORTCUT_BUTTON (applet_shortcut_button_get_type())
#define APPLET_SHORTCUT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_SHORTCUT_BUTTON,AppletShortcutButton))
#define APPLET_IS_SHORTCUT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_SHORTCUT_BUTTON))
#define APPLET_SHORTCUT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_SHORTCUT_BUTTON,AppletShortcutButtonClass))
#define APPLET_IS_SHORTCUT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_SHORTCUT_BUTTON))
#define APPLET_SHORTCUT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_SHORTCUT_BUTTON,AppletShortcutButtonClass))

typedef struct _AppletShortcutButton AppletShortcutButton;
typedef struct _AppletShortcutButtonPrivate AppletShortcutButtonPrivate;
typedef struct _AppletShortcutButtonClass AppletShortcutButtonClass;

struct _AppletShortcutButton
{
    AppletMenuButtonBase parent;
    AppletShortcutButtonPrivate *priv;
};
struct _AppletShortcutButtonClass
{
    AppletMenuButtonBaseClass parent_class;
};

GType	applet_shortcut_button_get_type (void);

AppletShortcutButton* 
applet_shortcut_button_new (const gchar *icon_name, const gchar *label_text);
void 
applet_shortcut_button_set_expand (AppletShortcutButton *self, gboolean expand); 
gboolean 
applet_shortcut_button_get_expand (AppletShortcutButton *self); 
void 
applet_shortcut_button_set_menu_enable (AppletShortcutButton *self, gboolean enable); 
gboolean 
applet_shortcut_button_get_menu_enable (AppletShortcutButton *self);

CdosPopupMenu* 
applet_shortcut_button_get_menu (AppletShortcutButton *self);
CdosPopupMenuItem * 
applet_shortcut_button_add_menu_item (AppletShortcutButton *self, 
                                      const gchar *text, 
                                      GCallback callback, 
                                      gpointer user_data);

void 
applet_shortcut_button_set_tooltip_toggle (AppletShortcutButton *self, gboolean is_toggle);
gboolean 
applet_shortcut_button_get_tooltip_toggle (AppletShortcutButton *self);

#endif //__APPLET_SHORTCUT_BUTTON_H__
