/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
//
// Created by zhangtao on 18-1-18.
// Email: zhangtao@cpu-os.ac.cn
//

#ifndef __APPLET_SHORTCUT_GROUP_H__
#define __APPLET_SHORTCUT_GROUP_H__

#include <glib-object.h>
#include "applet-shortcut-button.h"

#define APPLET_TYPE_SHORTCUT_GROUP (applet_shortcut_group_get_type())
#define APPLET_SHORTCUT_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_SHORTCUT_GROUP,AppletShortcutGroup))
#define APPLET_IS_SHORTCUT_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_SHORTCUT_GROUP))
#define APPLET_SHORTCUT_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_SHORTCUT_GROUP,AppletShortcutGroupClass))
#define APPLET_IS_SHORTCUT_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_SHORTCUT_GROUP))
#define APPLET_SHORTCUT_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_SHORTCUT_GROUP,AppletShortcutGroupClass))

typedef struct _AppletShortcutGroup AppletShortcutGroup;
typedef struct _AppletShortcutGroupPrivate AppletShortcutGroupPrivate;
typedef struct _AppletShortcutGroupClass AppletShortcutGroupClass;

struct _AppletShortcutGroup
{
    GObject parent;
    AppletShortcutGroupPrivate *priv;
};
struct _AppletShortcutGroupClass
{
    GObjectClass parent_class;
};

GType	applet_shortcut_group_get_type (void);
AppletShortcutGroup*    
applet_shortcut_group_new (void);

AppletShortcutButton*    
applet_shortcut_group_add_button (AppletShortcutGroup *self, 
                                  const gchar *icon_name, 
                                  const gchar *label_text, 
                                  GCallback  activate_callback, 
                                  gpointer user_data);

void    
applet_shortcut_group_remove_button (AppletShortcutGroup *self, AppletShortcutButton *button, gboolean destroy);
void    
applet_shortcut_group_set_expand (AppletShortcutGroup *self, gboolean expand);
gboolean    
applet_shortcut_group_get_expand (AppletShortcutGroup *self);

#endif //__APPLET_SHORTCUT_GROUP_H__
