#include "applet-nm-device-wired.h"
#include "applet-nm.h"

static void
applet_nm_device_wired_create_section (AppletNMDevice *self)
{
    applet_nm_device_create_section_real (self);
    if (self->connections == NULL)
    {
        clutter_actor_hide ((ClutterActor *)self->section);
    }
    else
    {
        clutter_actor_show ((ClutterActor *)self->section);
    }
}

AppletNMDeviceClass *
applet_nm_device_wired_class_new (AppletNM *applet)
{
    AppletNMDeviceClass *klass = g_new0 (AppletNMDeviceClass, 1);
    *klass = *applet->base_class;
    klass->create_section = applet_nm_device_wired_create_section;
    return klass;
}

AppletNMDeviceWired *
applet_nm_device_wired_new (AppletNM *applet, NMDevice *device, const GPtrArray *connections)
{
    AppletNMDeviceWired *self;

    self = g_new0 (AppletNMDeviceWired, 1);
    APPLET_NM_DEVICE (self)->klass = applet->ethernet_class;
    self->auto_connection_name = _("Auto Ethernet");
    self->category = DeviceWired;
    gboolean s = applet_nm_device_init ((AppletNMDevice *)self, applet, device, connections);
    if (!s)
    {
        g_free (self);
        return NULL;
    }
    return self;
}

void
applet_nm_device_wired_set_category (AppletNMDeviceWired *self, AppletNMDeviceType category)
{
    self->category = category;
    // nm_device_new (NULL, NULL);
}

AppletNMDeviceType
applet_nm_device_wired_get_category (AppletNMDeviceWired *self)
{
    return self->category;
}
