#ifndef __APPLET_NM_DEVICE_WIRELESS_H__
#define __APPLET_NM_DEVICE_WIRELESS_H__

#include "cdos-global.h"
#include <clutter/clutter.h>
#include "st.h"
#include "applet-nm-device.h"
#include "nm-client.h"
#include "cdos-popup-menu-item.h"
#include "applet-nm.h"

#define APPLET_NM_DEVICE_WIRELESS(obj) ((AppletNMDeviceWireless *)obj)

typedef struct _AppletNMDeviceWireless             AppletNMDeviceWireless;
typedef struct _AppletNMDeviceWirelessClass      	AppletNMDeviceWirelessClass;

typedef struct _AppletAP
{
    NMAccessPoint *ap;
    GSList *aps;
    GSList *connections;
    GBytes   *ssid;
    NM80211Mode mode;
    NMUtilsSecurityType security;
    CdosPopupBaseMenuItem *item;
    gboolean is_more;
} AppletAP;

struct _AppletNMDeviceWireless
{
    AppletNMDevice           parent_instance;
    AppletNMDeviceType       category;
    //CdosPopupMenuItem       *overflow_item;
    GSList                  *networks;
    AppletAP                *active_network;
    const gchar             *auto_connection_name;
    gulong                   ap_changed_id;
    gulong                   ap_added_id;
    gulong                   ap_removed_id;
    gulong                   menu_open_state_id; // add by niyl

};

AppletNMDeviceWireless *applet_nm_device_wireless_new (AppletNM *applet, NMDevice *device, const GPtrArray *connections);

AppletNMDeviceClass *applet_nm_device_wireless_class_new (AppletNM *applet);
// void
// applet_nm_device_wireless_create_section (AppletNMDeviceWireless *self);

NMConnection *applet_nm_device_wireless_create_automatic_connection (AppletNMDevice *self);

void applet_nm_device_wireless_set_category (AppletNMDeviceWireless *self, AppletNMDeviceType category);

AppletNMDeviceType applet_nm_device_wireless_get_category (AppletNMDeviceWireless *self);

void applet_nm_device_wireless_destroy (AppletNMDeviceWireless *self);

char *applet_nm_get_utf8_ssid (GBytes *ssid);

#endif
