#ifndef __APPLET_NM_DEVICE_H__
#define __APPLET_NM_DEVICE_H__

#include "cdos-global.h"
#include <clutter/clutter.h>
#include "st.h"

#include <NetworkManager.h>

#include "cdos-debug.h"
#include "applet-nm.h"

gboolean applet_nm_device_init (AppletNMDevice *self, 
                                AppletNM *applet,
                                NMDevice *device,
                                const GPtrArray *connections);

AppletNMDeviceClass *applet_nm_device_class_new (void);

gboolean applet_nm_device_connection_valid (AppletNMDevice *self, AppletNMConnection *connection);

gint applet_nm_device_find_connection (AppletNMDevice *self, const gchar *uuid);

gchar *applet_nm_device_get_status_label (AppletNMDevice *self);

CdosPopupSwitchMenuItem *applet_nm_device_get_statusItem (AppletNMDevice *self);

void applet_nm_device_destroy (AppletNMDevice *self);

void applet_nm_device_set_active_connection (AppletNMDevice *self, NMActiveConnection *activeConnection);
void applet_nm_device_get_active_connection (AppletNMDevice *self, gboolean activeConnection);
void applet_nm_device_remove_connection (AppletNMDevice *self, NMConnection *connection);
void applet_nm_device_check_connection (AppletNMDevice *self, NMConnection *connection);

void applet_nm_device_deactivate (AppletNMDevice *self);

void applet_nm_device_activate (AppletNMDevice *self);

gboolean applet_nm_device_get_connected (AppletNMDevice *self);

void applet_nm_device_set_enabled (AppletNMDevice *device, gboolean enableds);

void applet_nm_device_create_section_real (AppletNMDevice *self);

void applet_nm_device_clear_section_real (AppletNMDevice *self);

void applet_nm_device_destroy_real (AppletNMDevice *self);

NMConnection *applet_nm_device_create_auto_connection (AppletNMDevice *self);

guint8 applet_nm_signal_to_icon (guint8 strength);
#endif
