#ifndef __APPLET_NM__MENU_ITEM_H__
#define __APPLET_NM__MENU_ITEM_H__

#include "cdos-global.h"
#include <clutter/clutter.h>
#include "st.h"
#include "cdos-popup-switch-menu-item.h"
#include "applet-nm-device.h"

GType applet_nm_menu_item_get_type (void);

#define APPLET_TYPE_NM_MENU_ITEM		(applet_nm_menu_item_get_type ())
#define APPLET_NM_MENU_ITEM(obj)              (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_NM_MENU_ITEM, AppletNMMenuItem))
#define APPLET_IS_NM_MENU_ITEM(obj)           (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_NM_MENU_ITEM))
#define APPLET_NM_MENU_ITEM_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_NM_MENU_ITEM, AppletNMMenuItemClass))
#define APPLET_IS_NM_MENU_ITEM_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_NM_MENU_ITEM))
#define APPLET_NM_MENU_ITEM_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_NM_MENU_ITEM, AppletNMMenuItemClass))

typedef struct _AppletNMMenuItem        AppletNMMenuItem;
typedef struct _AppletNMMenuItemClass   AppletNMMenuItemClass;

struct _AppletNMMenuItem
{
    CdosPopupBaseMenuItem parent_instance;
    /* <private> */
    // AppletNMDevice *device;
    NMClient *client;
    NMConnection *connection;
    NMAccessPoint *ap;
    StWidget *label;
    StBoxLayout *icons;
    StIcon *signal_icon;
    StIcon *secure_icon;
    gulong update_id;
    guint8 last_strength;
};


struct _AppletNMMenuItemClass
{
    CdosPopupBaseMenuItemClass parent_class;
    void (*update_for_device) (AppletNMMenuItem *item, AppletNMDevice *device);
};

AppletNMMenuItem *
applet_nm_menu_item_new (NMConnection *connection, NMAccessPoint *ap, const char *title, PopupBaseMenuItemInit *params);

void applet_nm_menu_item_update_for_device (AppletNMMenuItem *self, AppletNMDevice *device);

void applet_nm_menu_item_update_ap (AppletNMMenuItem *item, NMAccessPoint *ap);

const gchar *applet_nm_get_icon (NMAccessPoint *ap, guint8 strength);

void applet_nm_menu_item_destroy (AppletNMMenuItem *item);


#endif
