#include "applet-nm-message-tray-source.h"

G_DEFINE_TYPE (AppletNMMessageTraySource, applet_nm_message_tray_source, CDOS_TYPE_SOURCE);

static void
applet_nm_message_tray_source_finalize (GObject *object)
{
    AppletNMMessageTraySource *self = APPLET_NM_MESSAGE_TRAY_SOURCE (object);

    cdos_source_set_summary_icon (CDOS_SOURCE (self), NULL);
    if (NULL != self->icon)
    {
        clutter_actor_destroy (self->icon);
    }
}
static void
applet_nm_message_tray_source_class_init (AppletNMMessageTraySourceClass *klass)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS (klass);
    gobject_class->finalize = applet_nm_message_tray_source_finalize;
}

static void
applet_nm_message_tray_source_init (AppletNMMessageTraySource *self)
{
    self->icon = st_icon_new ();
    st_icon_set_icon_name ((StIcon *)self->icon, "network-transmit-receive");
    st_icon_set_icon_size ((StIcon *)self->icon, SOURCE_ICON_SIZE);

    cdos_source_set_summary_icon (CDOS_SOURCE(self), self->icon);
}

/*公有函数定义*/
AppletNMMessageTraySource *
applet_nm_message_tray_source_new (void)
{
    AppletNMMessageTraySource *new_instance = g_object_new (APPLET_TYPE_NM_MESSAGE_TRAY_SOURCE, NULL);
    return new_instance;
}
