#ifndef __APPLET_NM_WIRELESS_SECTION_MENU_ITEM_H__
#define __APPLET_NM_WIRELESS_SECTION_MENU_ITEM_H__

#include "cdos-global.h"
#include <clutter/clutter.h>
#include "st.h"
#include "cdos-popup-switch-menu-item.h"
#include "applet-nm-device.h"

GType applet_nm_wireless_section_menu_item_get_type (void);

#define APPLET_TYPE_NM_WIRELESS_SECTION_MENU_ITEM		(applet_nm_wireless_section_menu_item_get_type ())
#define APPLET_NM_WIRELESS_SECTION_MENU_ITEM(obj)              (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_NM_WIRELESS_SECTION_MENU_ITEM, AppletNMWirelessSectionMenuItem))
#define APPLET_IS_NM_WIRELESS_SECTION_MENU_ITEM(obj)           (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_NM_WIRELESS_SECTION_MENU_ITEM))
#define APPLET_NM_WIRELESS_SECTION_MENU_ITEM_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_NM_WIRELESS_SECTION_MENU_ITEM, AppletNMWirelessSectionMenuItemClass))
#define APPLET_IS_NM_WIRELESS_SECTION_MENU_ITEM_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_NM_WIRELESS_SECTION_MENU_ITEM))
#define APPLET_NM_WIRELESS_SECTION_MENU_ITEM_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_NM_WIRELESS_SECTION_MENU_ITEM, AppletNMWirelessSectionMenuItemClass))

typedef struct _AppletNMWirelessSectionMenuItem AppletNMWirelessSectionMenuItem;
typedef struct _AppletNMWirelessSectionMenuItemClass AppletNMWirelessSectionMenuItemClass;

struct _AppletNMWirelessSectionMenuItem
{
    CdosPopupSwitchMenuItem parent_instance;
    AppletNMDevice *device;
    NMClient *client;
    AppletNMDeviceType device_type;
    gboolean software_enabled;
    gboolean hardware_enabled;
    gboolean (*hardware_get_enabled) (NMClient *client);
    gboolean (*get_enable_func) (NMClient *client);
    void (*set_enable_func) (NMClient *client, gboolean enabled);
};


struct _AppletNMWirelessSectionMenuItemClass
{
    CdosPopupSwitchMenuItemClass parent_class;
    void (*update_for_device) (AppletNMWirelessSectionMenuItem *item, AppletNMDevice *device);
};

AppletNMWirelessSectionMenuItem *
applet_nm_wireless_section_menu_item_new (NMClient *client, AppletNMDeviceType type, const char *title);

void applet_nm_wireless_section_menu_item_update_for_device (CdosPopupSwitchMenuItem *self, AppletNMDevice *device);

#endif
