/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
#include "applet-all-settings-button.h"
#include "applet-notifications2.h"
#include "config.h"

G_DEFINE_TYPE(AppletAllSettingsButton, applet_all_settings_button, APPLET_TYPE_SETTINGS_BUTTON);

static void
on_open_changed_callback (GObject *gobject,
                          GParamSpec *pspec,
                          gpointer user_data)
{
    applet_settings_button_open_state_show (APPLET_SETTINGS_BUTTON (gobject));
}

static void
applet_all_settings_button_activate (AppletSettingsButton *button)
{
    cdos_util_spawn_command_line ("found-control-center");
}

static void
applet_all_settings_button_init (AppletAllSettingsButton *self)
{
}

static void
applet_all_settings_button_class_init (AppletAllSettingsButtonClass *klass)
{
    AppletSettingsButtonClass *parent_class = APPLET_SETTINGS_BUTTON_CLASS (klass);
    parent_class->activate = applet_all_settings_button_activate;
}

AppletAllSettingsButton *
applet_all_settings_button_new (AppletNotifications2 *notification,
                                gboolean keep_notification,
                                gboolean show_open_state)
{
    AppletAllSettingsButton *settings_button;

    settings_button = g_object_new (APPLET_TYPE_ALL_SETTINGS_BUTTON,
                                    "icon-name", "notifications-all-settings",
                                    "icon-size", 24,
                                    "text", _("All Settings"),
                                    NULL);

    applet_settings_button_set_notification (APPLET_SETTINGS_BUTTON (settings_button), notification);
    applet_settings_button_keep_notification (APPLET_SETTINGS_BUTTON (settings_button), keep_notification);
    applet_settings_button_show_open_state (APPLET_SETTINGS_BUTTON (settings_button), show_open_state);

    g_signal_connect (settings_button,
                      "notify::open",
                      G_CALLBACK (on_open_changed_callback),
                      NULL);
                                    
    return settings_button;
}
