/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
#ifndef __APPLET_LUMINANCE_BUTTON_H__
#define __APPLET_LUMINANCE_BUTTON_H__

#include "applet-settings-button.h"

#define APPLET_TYPE_LUMINANCE_BUTTON                 (applet_luminance_button_get_type ())
#define APPLET_LUMINANCE_BUTTON(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_LUMINANCE_BUTTON, AppletLuminanceButton))
#define APPLET_LUMINANCE_BUTTON_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_LUMINANCE_BUTTON, AppletLuminanceButtonClass))
#define APPLET_IS_LUMINANCE_BUTTON(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_LUMINANCE_BUTTON))
#define APPLET_IS_LUMINANCE_BUTTON_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_LUMINANCE_BUTTON))
#define APPLET_LUMINANCE_BUTTON_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_LUMINANCE_BUTTON, AppletLuminanceButtonClass))

typedef struct _AppletLuminanceButton AppletLuminanceButton;
typedef struct _AppletLuminanceButtonClass AppletLuminanceButtonClass;
typedef struct _AppletLuminanceButtonPrivate AppletLuminanceButtonPrivate;

struct _AppletLuminanceButton
{
    AppletSettingsButton parent;

    AppletLuminanceButtonPrivate *priv;
};

struct _AppletLuminanceButtonClass
{
	AppletSettingsButtonClass parent_class;
};


GType applet_luminance_button_get_type (void) G_GNUC_CONST;

AppletLuminanceButton *applet_luminance_button_new (AppletNotifications2 *notification, 
                                                    gboolean keep_notification, 
                                                    gboolean show_open_state);

#endif /* __APPLET_LUMINANCE_BUTTON_H__ */
