/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
#ifndef __APPLET_NOTIFICATIONS2_H__
#define __APPLET_NOTIFICATIONS2_H__

#include <gio/gio.h>
#include "cdos-global.h"
#include "ui/cdos-message-tray.h"
#include "ui/cdos-applet.h"
#include "ui/cdos-icon-applet.h"
#include "ui/cdos-text-applet.h"
#include "ui/cdos-text-icon-applet.h"

#define APPLET_TYPE_NOTIFICATIONS2            (applet_notifications2_get_type ())
#define APPLET_NOTIFICATIONS2(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_NOTIFICATIONS2, AppletNotifications2))
#define APPLET_IS_NOTIFICATIONS2(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_NOTIFICATIONS2))
#define APPLET_NOTIFICATIONS2_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_NOTIFICATIONS2, AppletNotifications2Class))
#define APPLET_IS_NOTIFICATIONS2_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_NOTIFICATIONS2))
#define APPLET_NOTIFICATIONS2_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_NOTIFICATIONS2, AppletNotifications2Class))

typedef struct _AppletNotifications2 AppletNotifications2;
typedef struct _AppletNotifications2Private AppletNotifications2Private;
typedef struct _AppletNotifications2Class AppletNotifications2Class;

typedef struct _AppletAirplaneModeButton AppletAirplaneModeButton;
typedef struct _AppletQuietHoursButton AppletQuietHoursButton;
typedef struct _AppletLuminanceButton AppletLuminanceButton;
typedef struct _AppletProjectButton AppletProjectButton;
typedef struct _AppletAllSettingsButton AppletAllSettingsButton;

struct _AppletNotifications2
{
    CdosTextIconApplet parent_instance;

    guint notification_count;
    guint notification_unshown;

    GList *notifications;
    ClutterActor *actor;
    StWidget *scroll_view;
    ClutterActor *box;
    ClutterActor *calendar;
    StLabel     *timelabel;
    StLabel     *lunarlabel;
    StWidget *media_player;
    StButton *clear_all;
    ClutterActor *p_crit_icon;
    ClutterActor *p_alt_crit_icon;
    gboolean ignore_transient_notifications;

    gfloat pos_x;
    gfloat pos_y;
    guint8 orig_opacity;
    gint transition_state;

    GdkPixbuf  *init_pixbuf;
    GdkPixbuf  *single_pixbuf;
    GdkPixbuf  *double_pixbuf;
    ClutterActor *prev_focus;
    gulong  event_captured_id;
    
    StBoxLayout *main_box;
    StBoxLayout *settings_center_box;
    AppletAirplaneModeButton *airplane_button;
    AppletQuietHoursButton *quiet_button;
    AppletLuminanceButton *luminance_button;
    AppletProjectButton *project_button;
    AppletAllSettingsButton *settings_button;
    guint timer_id;

    GList *players;

    AppletNotifications2Private *priv;
};

struct _AppletNotifications2Class
{
    CdosTextIconAppletClass parent_class;
    /*signals*/
    void (*notifications_show) (AppletNotifications2 *self);
    void (*notifications_hide) (AppletNotifications2 *self);
};

GType applet_notifications2_get_type (void);

CdosApplet *applet_notifications2_main (MetaData *metadata, StSide orientation, gfloat panel_height, gchar *instanceId);
void applet_notifications2_show (AppletNotifications2 *self);
void applet_notifications2_hide (AppletNotifications2 *self);

#endif // __APPLET_NOTIFICATIONS2_H__
