/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
#ifndef __APPLET_QUIET_HOURS_BUTTON_H__
#define __APPLET_QUIET_HOURS_BUTTON_H__

#include <glib.h>
#include "st.h"
#include "applet-settings-button.h"

#define APPLET_TYPE_QUIET_HOURS_BUTTON                 (applet_quiet_hours_button_get_type ())
#define APPLET_QUIET_HOURS_BUTTON(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_QUIET_HOURS_BUTTON, AppletQuietHoursButton))
#define APPLET_QUIET_HOURS_BUTTON_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_QUIET_HOURS_BUTTON, AppletQuietHoursButtonClass))
#define APPLET_IS_QUIET_HOURS_BUTTON(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_QUIET_HOURS_BUTTON))
#define APPLET_IS_QUIET_HOURS_BUTTON_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_QUIET_HOURS_BUTTON))
#define APPLET_QUIET_HOURS_BUTTON_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_QUIET_HOURS_BUTTON, AppletQuietHoursButtonClass))

typedef struct _AppletQuietHoursButton AppletQuietHoursButton;
typedef struct _AppletQuietHoursButtonClass AppletQuietHoursButtonClass;
typedef struct _AppletQuietHoursButtonPrivate AppletQuietHoursButtonPrivate;

struct _AppletQuietHoursButton
{
    AppletSettingsButton parent;

    AppletQuietHoursButtonPrivate *priv;
};

struct _AppletQuietHoursButtonClass
{
	AppletSettingsButtonClass parent_class;
};


GType applet_quiet_hours_button_get_type (void) G_GNUC_CONST;

AppletQuietHoursButton *applet_quiet_hours_button_new (AppletNotifications2 *notification, 
                                                       gboolean keep_notification, 
                                                       gboolean show_open_state);

#endif /* __APPLET_QUIET_HOURS_BUTTON_H__ */
