/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
#ifndef __APPLET_SETTINGS_BUTTON_H__
#define __APPLET_SETTINGS_BUTTON_H__

#include <glib.h>
#include "st.h"
#include "applet-notifications2.h"

#define APPLET_TYPE_SETTINGS_BUTTON                 (applet_settings_button_get_type ())
#define APPLET_SETTINGS_BUTTON(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_SETTINGS_BUTTON, AppletSettingsButton))
#define APPLET_SETTINGS_BUTTON_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_SETTINGS_BUTTON, AppletSettingsButtonClass))
#define APPLET_IS_SETTINGS_BUTTON(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_SETTINGS_BUTTON))
#define APPLET_IS_SETTINGS_BUTTON_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_SETTINGS_BUTTON))
#define APPLET_SETTINGS_BUTTON_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_SETTINGS_BUTTON, AppletSettingsButtonClass))

typedef struct _AppletSettingsButton AppletSettingsButton;
typedef struct _AppletSettingsButtonClass AppletSettingsButtonClass;
typedef struct _AppletSettingsButtonPrivate AppletSettingsButtonPrivate;

struct _AppletSettingsButton
{
    StWidget parent;
    AppletSettingsButtonPrivate *priv;
};

struct _AppletSettingsButtonClass
{
	StWidgetClass parent_class;
	/*signals*/
	void (*activate) (AppletSettingsButton *settings_button);
};


GType applet_settings_button_get_type (void) G_GNUC_CONST;

AppletSettingsButton *applet_settings_button_new (const gchar *icon_name, gint icon_size, const gchar *text);
void applet_settings_button_set_icon_name (AppletSettingsButton *settings_button, const gchar *icon_name);
void applet_settings_button_set_icon_size (AppletSettingsButton *settings_button, gint size);
void applet_settings_button_set_text (AppletSettingsButton *settings_button, const gchar *text);

void applet_settings_button_set_notification (AppletSettingsButton *settings_button, AppletNotifications2 *notification);

AppletNotifications2 *applet_settings_button_get_notification (AppletSettingsButton *settings_button);
void applet_settings_button_keep_notification (AppletSettingsButton *settings_button, gboolean keep_notification);
void applet_settings_button_set_open (AppletSettingsButton *settings_button, gboolean open);
gboolean applet_settings_button_is_open (AppletSettingsButton *settings_button);
void applet_settings_button_show_open_state (AppletSettingsButton *settings_button, gboolean show_open_state);
void applet_settings_button_open_state_show (AppletSettingsButton *settings_button);

#endif /* __APPLET_SETTINGS_BUTTON_H__ */
