#ifndef __CDOS_DRIVE_MENU_ITEM_H__
#define __CDOS_DRIVE_MENU_ITEM_H__

#include "cdos-popup-base-menu-item.h"

#define CDOS_TYPE_DRIVE_MENU_ITEM                 (cdos_drive_menu_item_get_type ())
#define CDOS_DRIVE_MENU_ITEM(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_DRIVE_MENU_ITEM, CdosDriveMenuItem))
#define CDOS_DRIVE_MENU_ITEM_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_DRIVE_MENU_ITEM, CdosDriveMenuItemClass))
#define CDOS_IS_DRIVE_MENU_ITEM(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_DRIVE_MENU_ITEM))
#define CDOS_IS_DRIVE_MENU_ITEM_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_DRIVE_MENU_ITEM))
#define CDOS_DRIVE_MENU_ITEM_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_DRIVE_MENU_ITEM, CdosDriveMenuItemClass))

typedef struct _CdosDriveMenuItem        CdosDriveMenuItem;
typedef struct _CdosDriveMenuItemClass   CdosDriveMenuItemClass;
typedef struct _CdosDriveMenuItemPrivate CdosDriveMenuItemPrivate;

struct _CdosDriveMenuItem
{
  CdosPopupBaseMenuItem parent;

  CdosDriveMenuItemPrivate *priv;
};

struct _CdosDriveMenuItemClass
{
  CdosPopupBaseMenuItemClass parent_class;
};

typedef enum 
{
  ACTION_OPEN,
  ACTION_EJECT
} MountAction;

GType cdos_drive_menu_item_get_type (void) G_GNUC_CONST;

CdosDriveMenuItem *
cdos_drive_menu_item_new(GMount *mount, MountAction action);

GMount *cdos_drive_menu_item_get_mount (CdosDriveMenuItem *self);

#endif /* __CDOS_DRIVE_MENU_ITEM_H__ */
