#ifndef __APPLET_SOUND_H__
#define SLIDER_SCROLL_STEP 0.05 /* Slider scrolling step in % */
#define VOLUME_ADJUSTMENT_STEP 0.05 /* Volume adjustment step in % */
#define __APPLET_SOUND_H__

#define WITH_INTROSPECTION
#define VOLUME_NOTIFY_ID 1
#define SOUND_ICON_SIZE 28

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>

#include "ui/cdos-extension.h"
#include "gvc/gvc-mixer-control.h"
#include "ui/cdos-popup-submenu-menu-item.h"
#include "ui/cdos-popup-menu.h"
#include "ui/cdos-popup-menu-manager.h"
#include "ui/cdos-popup-switch-menu-item.h"
#include "ui/cdos-text-icon-applet.h"
#include "ui/cdos-popup-separator-menu-item.h"
#include "cdos-scale.h"


#define APPLET_TYPE_SOUND (applet_sound_get_type ())

#define APPLET_SOUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_SOUND, AppletSound))

#define APPLET_IS_SOUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_SOUND))

#define APPLET_SOUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_SOUND, AppletSoundClass))

#define APPLET_IS_SOUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_SOUND))

#define APPLET_SOUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_SOUND, AppletSoundClass))


typedef struct _AppletSound AppletSound;
typedef struct _AppletSoundClass AppletSoundClass;

/* instance structure */
struct _AppletSound
{
    CdosIconApplet parent_instance;

    /*成员变量*/
    MetaData *metadata;
    gboolean *hide_systray;
    CdosPopupMenuManager *menu_manager;
    CdosPopupMenu *menu; /*cdos_applet_get_popupmenu in applet.h*/
    StWidget *mute_out_switch;//StButton，toogled事件接收
    StWidget *mute_in_switch;
    StWidget *output_box;
    StWidget *input_box;
    CdosPopupMenuItem *sound_settings;
    gboolean show_track;
    gboolean show_album;
    guint truncate_text;

    /*私有变量*/
    GvcMixerControl *p_control; /*gvc_mixer_control_new                 (const char *name);*/
    GvcMixerStream *p_output; /*1409:gvc_mixer_control_get_default_source   (GvcMixerControl *control);*/
    GvcMixerStream *p_input;
    gulong p_input_volume_id;
    gulong p_output_volume_id;
    gulong p_output_notify_id;
    gulong p_input_muted_id;
    gulong p_output_muted_id;
    gboolean p_volume_control_shown;
    guint p_icon_timeout_id;
    gfloat p_volume_max;
    gchar *p_icon_name;
    gchar *p_icon_path;
    CdosScale *output_slider;
    CdosScale *input_slider;
    StWidget *output_text;//StLabel 3d%%
    StWidget *input_text;
    StIcon *output_icon;//StIcon insert into StButton
    StIcon *input_icon;
    StWidget *input_item_class;
    StWidget *output_item_class;//容纳slider，StBoxLayout 
    CdosPopupSubmenuMenuItem *p_select_device_item;
    gboolean p_show_input;
    CdosPopupMenu *applet_context_menu_p;
};

/* class structure */
struct _AppletSoundClass
{
    CdosIconAppletClass parent_class;

    /*信号*/
    void (*players_loaded) (AppletSound *self, gpointer user_data);
};

GType applet_sound_get_type (void);

void applet_sound_on_settings_changed_cb (GObject *obj, gpointer user_data);

void applet_sound_on_applet_removed_from_panel (AppletSound *self);
gboolean applet_sound_on_applet_clicked_cb (GObject *obj, ClutterEvent *event, gpointer user_data);
void applet_sound_set_icon_name (AppletSound *self, const gchar *actor);
void applet_sound_register_systray_icons (AppletSound *self);
void applet_sound_unregister_systray_icons (AppletSound *self);

/*FIXME:暂时不写!*/
void applet_sound_set_applet_icon (AppletSound *self, GObject *player, gchar *path);
void applet_sound_set_applet_text (AppletSound *self, GObject *player);
void applet_sound_set_applet_text_icon (AppletSound *self, GObject *player, gchar *path);

/*不确定*/
CdosApplet *applet_sound_main (MetaData *metadata, StSide orientation, guint panel_height, gchar *instanceId);

#endif
