// Created by zhangtao on 16-4-16.

#ifndef __APPLET_APP_GROUP_H__
#define __APPLET_APP_GROUP_H__
#include <clutter/clutter.h>
#include <glib-object.h>
#include <meta/workspace.h>

#include "applet-window-list-private.h"
#include "cdos-app.h"
#include "st.h"
#include "applet-app-context-menu.h"
#include "applet-app-thumbnail-hover-menu.h"
#include "applet-app-button.h"
#include "applet-button-box.h"

#define APPLET_TYPE_APP_GROUP (applet_app_group_get_type ())
#define APPLET_APP_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_APP_GROUP, AppletAppGroup))
#define APPLET_IS_APP_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_APP_GROUP))
#define APPLET_APP_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_APP_GROUP, AppletAppGroupClass))
#define APPLET_IS_APP_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((obj), APPLET_TYPE_APP_GROUP))
#define APPLET_APP_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_APP_GROUP, AppletAppGroupClass))

typedef struct _AppletAppGroup AppletAppGroup;
typedef struct _AppletAppGroupPrivate AppletAppGroupPrivate;
typedef struct _AppletAppGroupClass AppletAppGroupClass;

struct _AppletAppGroup
{
    StWidget parent;
    /*private*/
    AppletAppGroupPrivate *priv;
};

struct _AppletAppGroupClass
{
    StWidgetClass parent_class;
};

GType applet_app_group_get_type (void);

AppletAppGroup *applet_app_group_new (CdosApp *app, gboolean is_favorite_app, MetaWorkspace *meta_workspace);

void applet_app_group_show (AppletAppGroup *self);

void applet_app_group_hide (AppletAppGroup *self);

void applet_app_group_update_meta_windows (AppletAppGroup *self, MetaWorkspace *meta_workspace);

void applet_app_group_window_removed (AppletAppGroup *self, MetaWorkspace *meta_workspace, MetaWindow *meta_window);

void applet_app_group_is_favorite (AppletAppGroup *self, gboolean is_favorite);

gboolean applet_app_group_get_is_favorite_app (AppletAppGroup *self);

gboolean applet_app_group_get_was_favorite_app (AppletAppGroup *self);

void applet_app_group_set_buttons_condense (AppletAppGroup *self, gboolean condense);

AppletButtonBox *applet_app_group_get_window_button_box (AppletAppGroup *self);

void applet_app_group_set_orientation (AppletAppGroup *self, StSide orientation);

#endif //__APPLET_APP_GROUP_H__
