// Created by zhangtao on 16-4-16.

#ifndef __APPLET_WINDOW_THUMBNAIL_H__
#define __APPLET_WINDOW_THUMBNAIL_H__

#include <glib-object.h>
#include <meta/window.h>
#include <clutter/clutter.h>
#include "cdos-app.h"
#include "applet-window-list-private.h"
#include "st.h"

#define APPLET_TYPE_WINDOW_THUMBNAIL (applet_window_thumbnail_get_type ())
#define APPLET_WINDOW_THUMBNAIL(obj)                                                                                   \
    (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_WINDOW_THUMBNAIL, AppletWindowThumbnail))
#define APPLET_IS_WINDOW_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_WINDOW_THUMBNAIL))
#define APPLET_WINDOW_THUMBNAIL_CLASS(klass)                                                                           \
    (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_WINDOW_THUMBNAIL, AppletWindowThumbnailClass))
#define APPLET_IS_WINDOW_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((obj), APPLET_TYPE_WINDOW_THUMBNAIL))
#define APPLET_WINDOW_THUMBNAIL_GET_CLASS(obj)                                                                         \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_WINDOW_THUMBNAIL, AppletWindowThumbnailClass))

typedef struct _AppletWindowThumbnail AppletWindowThumbnail;
typedef struct _AppletWindowThumbnailPrivate AppletWindowThumbnailPrivate;

typedef struct _AppletWindowThumbnailClass AppletWindowThumbnailClass;
typedef struct _AppletWindowThumbnailClassPrivate AppletWindowThumbnailClassPrivate;

struct _AppletWindowThumbnail
{
    StWidget parent;
    AppletWindowThumbnailPrivate *priv;
};

struct _AppletWindowThumbnailClass
{
    StWidgetClass parent_class;
    AppletWindowThumbnailClassPrivate *priv;
};

GType applet_window_thumbnail_get_type (void);
AppletWindowThumbnail *applet_window_thumbnail_new (CdosApp *app, gboolean is_favorite, MetaWindow *meta_window);
gboolean applet_window_thumbnail_need_reflush (AppletWindowThumbnail *self);

void applet_window_thumbnail_is_favorite (AppletWindowThumbnail *self, gboolean is_added);

MetaWindow *applet_window_thumbnail_get_meta_window (AppletWindowThumbnail *self);

CdosApp *applet_window_thumbnail_get_app (AppletWindowThumbnail *self);

StWidget *applet_window_thumbnail_get_actor (AppletWindowThumbnail *self);

void applet_window_thumbnail_set_scale (AppletWindowThumbnail *self, gfloat scale);

gfloat applet_window_thumbnail_get_scale (AppletWindowThumbnail *self);

void applet_window_thumbnail_set_no_thumbnail (AppletWindowThumbnail *self, gboolean no_thumbnail);

#endif //__APPLET_WINDOW_THUMBNAIL_H__
