/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 * * Based on code from cinnamon-app-system.h in Cinnamon. 
 * Copyright (c) 1997-2003 by The XFree86 Project, Inc.
 * This software is published by the license of CPU-OS License, you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_APP_SYSTEM_H__
#define __CDOS_APP_SYSTEM_H__

#include <gio/gio.h>
#include <clutter/clutter.h>
#include <meta/window.h>
#define GMENU_I_KNOW_THIS_IS_UNSTABLE
#include <gmenu-tree.h>

#include "cdos-app.h"

#define CDOS_TYPE_APP_SYSTEM                 (cdos_app_system_get_type ())
#define CDOS_APP_SYSTEM(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_APP_SYSTEM, CdosAppSystem))
#define CDOS_APP_SYSTEM_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_APP_SYSTEM, CdosAppSystemClass))
#define CDOS_IS_APP_SYSTEM(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_APP_SYSTEM))
#define CDOS_IS_APP_SYSTEM_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_APP_SYSTEM))
#define CDOS_APP_SYSTEM_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_APP_SYSTEM, CdosAppSystemClass))

typedef struct _CdosAppSystem CdosAppSystem;
typedef struct _CdosAppSystemClass CdosAppSystemClass;
typedef struct _CdosAppSystemPrivate CdosAppSystemPrivate;

struct _CdosAppSystem
{
  GObject parent;

  CdosAppSystemPrivate *priv;
};

struct _CdosAppSystemClass
{
  GObjectClass parent_class;

  void (*installed_changed)(CdosAppSystem *appsys, gpointer user_data);
  void (*removed_changed)(CdosAppSystem *appsys, gpointer user_data);
  void (*favorites_changed)(CdosAppSystem *appsys, gpointer user_data);
};

GType           cdos_app_system_get_type    (void) G_GNUC_CONST;

CdosAppSystem *cdos_app_system_get_default (void);

GMenuTree      *cdos_app_system_get_tree                     (CdosAppSystem *system);

CdosApp       *cdos_app_system_lookup_app                   (CdosAppSystem  *system,
                                                               const char      *id);

CdosApp       *cdos_app_system_lookup_app_by_tree_entry     (CdosAppSystem  *system,
                                                               GMenuTreeEntry  *entry);
CdosApp       *cdos_app_system_lookup_app_for_path          (CdosAppSystem  *system,
                                                               const char      *desktop_path);
CdosApp       *cdos_app_system_lookup_heuristic_basename    (CdosAppSystem  *system,
                                                               const char      *id);


GSList         *cdos_app_system_get_all                   (CdosAppSystem  *system);

GSList         *cdos_app_system_get_running               (CdosAppSystem  *self);

GSList         *cdos_app_system_initial_search            (CdosAppSystem  *system,
                                                            GSList          *terms);
GSList         *cdos_app_system_subsearch                 (CdosAppSystem  *system,
                                                            GSList          *previous_results,
                                                            GSList          *terms);

GMenuTreeEntry *cdos_app_system_lookup_entry_by_name    (CdosAppSystem *system, gchar *name_str);

CdosApp       *cdos_app_system_lookup_desktop_wmclass (CdosAppSystem *system, const char *wmclass);
CdosApp       *cdos_app_system_lookup_startup_wmclass (CdosAppSystem *system, const char *wmclass);

#endif /* __CDOS_APP_SYSTEM_H__ */
