/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 * * Based on code from cinnamon-app-usage.h in Cinnamon.
 * Copyright (c) 1997-2003 by The XFree86 Project, Inc.
 * This software is published by the license of CPU-OS License, you can use and
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us
 * by email <support_os@cpu-os.ac.cn>
 *
 **/
/* cdos-app-usage.h */
/* insert (c)/licensing information) */

#ifndef __CDOS_APP_USAGE_H__
#define __CDOS_APP_USAGE_H__

#include <glib.h>
#include <glib-object.h>
#include "cdos-app.h"
#include "cdos-window-tracker.h"

G_BEGIN_DECLS

// clang-format off
#define CDOS_TYPE_APP_USAGE (cdos_app_usage_get_type())
// G_DECLARE_FINAL_TYPE (CdosAppUseage, cdos_app_usage, CDOS, APP_USAGE, GObject)
#define CDOS_APP_USAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_APP_USAGE,CdosAppUsage))
#define CDOS_APP_USAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_APP_USAGE,CdosAppUsageClass))
#define CDOS_IS_APP_USAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_APP_USAGE))
#define CDOS_IS_APP_USAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),CDOS_TYPE_APP_USAGE))
#define CDOS_APP_USAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_APP_USAGE,CdosAppUsageClass))
#define USAGE_APP (g_strconcat("", g_get_home_dir(), "/.cdos/configs/usage-app.xml", NULL))
// clang-format on

typedef struct _CdosAppUsage CdosAppUsage;
typedef struct _CdosAppUsageClass CdosAppUsageClass;
typedef struct _CdosAppUsagePrivate CdosAppUsagePrivate;
typedef struct _UsageData UsageData;

struct _CdosAppUsage
{
    GObject parent;
    guint save_id;
    gboolean enable_monitoring;
    GSettings *privacy_settings;
    GList *app_list;

    CdosAppUsagePrivate *priv;
};

struct _CdosAppUsageClass
{
    GObjectClass parent_class;

    void (*usage_changed) (CdosAppUsage *self);
};

struct _UsageData
{
    gchar *desktop_id;
    gdouble score;
    gchar *last_seen;
    CdosApp *app;
};

GType cdos_app_usage_get_type (void) G_GNUC_CONST;

CdosAppUsage *cdos_app_usage_get_default (void);

GList *cdos_app_usage_get_list (CdosAppUsage *self);

void cdos_app_usage_remove_app (CdosAppUsage *self, CdosApp *app);

void cdos_app_usage_test (CdosAppUsage *self);

G_END_DECLS

#endif /* __CDOS_APP_USAGE_H__ */
