/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
/*
 * Copyright (C) 2011 Red Hat, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Suite 500, Boston, MA
 * 02110-1335, USA.
 *
 * Author: Cosimo Cecchi <cosimoc@redhat.com>
 *
 */

#ifndef __CDOS_BASE_MOUNT_OPERATION_H__
#define __CDOS_BASE_MOUNT_OPERATION_H__

#include <gio/gio.h>

G_BEGIN_DECLS

#define CDOS_TYPE_BASE_MOUNT_OPERATION (cdos_base_mount_operation_get_type ())
#define CDOS_BASE_MOUNT_OPERATION(o)                                                                                   \
    (G_TYPE_CHECK_INSTANCE_CAST ((o), CDOS_TYPE_BASE_MOUNT_OPERATION, CdosBaseMountOperation))
#define CDOS_BASE_MOUNT_OPERATION_CLASS(k)                                                                             \
    (G_TYPE_CHECK_CLASS_CAST ((k), CDOS_TYPE_BASE_MOUNT_OPERATION, CdosBaseMountOperationClass))
#define CDOS_IS_BASE_MOUNT_OPERATION(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), CDOS_TYPE_BASE_MOUNT_OPERATION))
#define CDOS_IS_BASE_MOUNT_OPERATION_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), CDOS_TYPE_BASE_MOUNT_OPERATION))
#define CDOS_BASE_MOUNT_OPERATION_GET_CLASS(o)                                                                         \
    (G_TYPE_INSTANCE_GET_CLASS ((o), CDOS_TYPE_BASE_MOUNT_OPERATION, CdosBaseMountOperationClass))

typedef struct _CdosBaseMountOperation CdosBaseMountOperation;
typedef struct _CdosBaseMountOperationClass CdosBaseMountOperationClass;
typedef struct _CdosBaseMountOperationPrivate CdosBaseMountOperationPrivate;

struct _CdosBaseMountOperation
{
    GMountOperation parent_instance;

    CdosBaseMountOperationPrivate *priv;
};

struct _CdosBaseMountOperationClass
{
    GMountOperationClass parent_class;
};


GType cdos_base_mount_operation_get_type (void);
GMountOperation *cdos_base_mount_operation_new (void);

GArray *cdos_base_mount_operation_get_show_processes_pids (CdosBaseMountOperation *self);
gchar **cdos_base_mount_operation_get_show_processes_choices (CdosBaseMountOperation *self);
gchar *cdos_base_mount_operation_get_show_processes_message (CdosBaseMountOperation *self);

G_END_DECLS

#endif /* __CDOS_BASE_MOUNT_OPERATION_H__ */
