/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */

#ifndef __CDOS_BASE_UTIL_H__
#define __CDOS_BASE_UTIL_H__

#include <gio/gio.h>
#include <clutter/clutter.h>

G_BEGIN_DECLS

typedef struct _XdgPath
{
    gchar *type;
    gchar *real_path;
} XdgPath;

char *cdos_base_util_get_label_for_uri (const char *text_uri);
GIcon *cdos_base_util_get_icon_for_uri (const char *text_uri);

void cdos_base_util_set_hidden_from_pick (ClutterActor *actor, gboolean hidden);

void cdos_base_util_get_transformed_allocation (ClutterActor *actor, ClutterActorBox *box);

int cdos_base_util_get_week_start (void);

char *cdos_base_util_normalize_and_casefold (const char *str);

char *cdos_base_util_format_date (const char *format, gint64 time_ms);

ClutterModifierType cdos_base_util_get_event_state (ClutterEvent *event);

gboolean cdos_base_util_write_string_to_stream (GOutputStream *stream, const char *str, GError **error);

char *cdos_base_util_get_file_contents_utf8_sync (const char *path, GError **error);

void cdos_base_util_breakpoint (void);

gboolean cdos_base_util_parse_search_provider (const char *data,
                                               char **name,
                                               char **url,
                                               GList **langs,
                                               char **icon_data_uri,
                                               GError **error);

void cdos_base_util_shader_effect_set_double_uniform (ClutterShaderEffect *effect, const gchar *name, gdouble value);

gchar *cdos_base_util_str_tolower (gchar *str);

gchar *cdos_base_util_str_toupper (gchar *str);

G_END_DECLS

#endif /* __CINNAMON_UTIL_H__ */
