/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_DOC_SYSTEM_H__
#define __CDOS_DOC_SYSTEM_H__

#include <gio/gio.h>
#include <gtk/gtk.h>

#define CDOS_TYPE_DOC_SYSTEM (cdos_doc_system_get_type ())
#define CDOS_DOC_SYSTEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_DOC_SYSTEM, CdosDocSystem))
#define CDOS_DOC_SYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_DOC_SYSTEM, CdosDocSystemClass))
#define CDOS_IS_DOC_SYSTEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_DOC_SYSTEM))
#define CDOS_IS_DOC_SYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_DOC_SYSTEM))
#define CDOS_DOC_SYSTEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_DOC_SYSTEM, CdosDocSystemClass))

typedef struct _CdosDocSystem CdosDocSystem;
typedef struct _CdosDocSystemClass CdosDocSystemClass;
typedef struct _CdosDocSystemPrivate CdosDocSystemPrivate;

struct _CdosDocSystem
{
    GObject parent;

    CdosDocSystemPrivate *priv;
};

struct _CdosDocSystemClass
{
    GObjectClass parent_class;
};

GType cdos_doc_system_get_type (void) G_GNUC_CONST;

CdosDocSystem *cdos_doc_system_get_default (void);

GSList *cdos_doc_system_get_all (CdosDocSystem *system);

GtkRecentInfo *cdos_doc_system_lookup_by_uri (CdosDocSystem *system, const char *uri);

void cdos_doc_system_queue_existence_check (CdosDocSystem *system, guint n_items);

void cdos_doc_system_open (CdosDocSystem *system, GtkRecentInfo *info, int workspace);

#endif /* __CDOS_DOC_SYSTEM_H__ */
