/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *
 * This software is published by the license of CPU-OS License, you can use and
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us
 * by email <support_os@cpu-os.ac.cn>
 *
 **/
/* applet-recently-parser.h */

#ifndef __CDOS_RECENTLY_PARSER_H__
#define __CDOS_RECENTLY_PARSER_H__

#include <glib-object.h>
#include <glib.h>
#include "cdos-app.h"

G_BEGIN_DECLS

// clang-format off
#define CDOS_TYPE_RECENTLY_PARSER (cdos_recently_parser_get_type ())
#define CDOS_RECENTLY_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_RECENTLY_PARSER, CdosRecentlyParser))
#define CDOS_RECENTLY_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_RECENTLY_PARSER, CdosRecentlyParserClass))
#define CDOS_IS_RECENTLY_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_RECENTLY_PARSER))
#define CDOS_IS_RECENTLY_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_RECENTLY_PARSER))
#define CDOS_RECENTLY_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_RECENTLY_PARSER, CdosRecentlyParserClass))

typedef struct _CdosRecentlyAppData CdosRecentlyAppData;
struct _CdosRecentlyAppData
{
    gchar *id;
    gchar *last_install;
};

typedef struct _CdosRecentlyParser CdosRecentlyParser;
typedef struct _CdosRecentlyParserClass CdosRecentlyParserClass;
typedef struct _CdosRecentlyParserPrivate CdosRecentlyParserPrivate;

struct _CdosRecentlyParser
{
    GObject parent;
    /* private */
    CdosRecentlyParserPrivate *priv;
};

struct _CdosRecentlyParserClass
{
    GObjectClass parent_class;
    void (*recent_changed) (CdosRecentlyParser *self);
};

/* member functions */
GType cdos_recently_parser_get_type (void) G_GNUC_CONST;

CdosRecentlyParser *cdos_recently_parser_new (void);

void cdos_recently_parser_remove_app (CdosRecentlyParser *self, const gchar *desktop_id);

GList *cdos_recently_parser_get_list (CdosRecentlyParser *self);

GList *cdos_recently_parser_get_app_list (CdosRecentlyParser *self);

G_END_DECLS

#endif /* __CDOS_RECENTLY_PARSER_H__ */
