/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 * * Based on code from cinnamon-screenshot.h in Cinnamon. 
 * Copyright (c) 1997-2003 by The XFree86 Project, Inc.
 * This software is published by the license of CPU-OS License, you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_SCREENSHOT_H__
#define __CDOS_SCREENSHOT_H__

/**
 * SECTION:cdos-screenshot
 * @short_description: Grabs screenshots of areas and/or windows
 *
 * The #CdosScreenshot object is used to take screenshots of screen
 * areas or windows and write them out as png files.
 *
 */

typedef struct _CdosScreenshot      CdosScreenshot;
typedef struct _CdosScreenshotClass CdosScreenshotClass;

#define CDOS_TYPE_SCREENSHOT              (cdos_screenshot_get_type ())
#define CDOS_SCREENSHOT(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), CDOS_TYPE_SCREENSHOT, CdosScreenshot))
#define CDOS_SCREENSHOT_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_SCREENSHOT, CdosScreenshotClass))
#define CDOS_IS_SCREENSHOT(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), CDOS_TYPE_SCREENSHOT))
#define CDOS_IS_SCREENSHOT_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_SCREENSHOT))
#define CDOS_SCREENSHOT_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_SCREENSHOT, CdosScreenshotClass))

GType cdos_screenshot_get_type (void) G_GNUC_CONST;

CdosScreenshot *cdos_screenshot_new (void);

typedef void (*CdosScreenshotCallback)  (CdosScreenshot *screenshot,
                                           gboolean success,
                                           cairo_rectangle_int_t *screenshot_area);

void    cdos_screenshot_screenshot_area      (CdosScreenshot *screenshot,
                                                gboolean include_cursor,
                                                int x,
                                                int y,
                                                int width,
                                                int height,
                                                const char *filename,
                                                CdosScreenshotCallback callback);

void    cdos_screenshot_screenshot_window    (CdosScreenshot *screenshot,
                                                gboolean include_frame,
                                                gboolean include_cursor,
                                                const char *filename,
                                                CdosScreenshotCallback callback);

void    cdos_screenshot_screenshot           (CdosScreenshot *screenshot,
                                                gboolean include_cursor,
                                                const char *filename,
                                                CdosScreenshotCallback callback);

#endif /* ___CDOS_SCREENSHOT_H__ */
