/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_WINDOW_TRACKER_H__
#define __CDOS_WINDOW_TRACKER_H__

#include <glib-object.h>
#include <glib.h>
#include <meta/window.h>

#include "cdos-app.h"
#include "cdos-app-system.h"

G_BEGIN_DECLS

typedef struct _CdosWindowTracker CdosWindowTracker;
typedef struct _CdosWindowTrackerClass CdosWindowTrackerClass;
typedef struct _CdosWindowTrackerPrivate CdosWindowTrackerPrivate;

#define CDOS_TYPE_WINDOW_TRACKER (cdos_window_tracker_get_type ())
#define CDOS_WINDOW_TRACKER(object) (G_TYPE_CHECK_INSTANCE_CAST ((object), CDOS_TYPE_WINDOW_TRACKER, CdosWindowTracker))
#define CDOS_WINDOW_TRACKER_CLASS(klass)                                                                               \
    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_WINDOW_TRACKER, CdosWindowTrackerClass))
#define CDOS_IS_WINDOW_TRACKER(object) (G_TYPE_CHECK_INSTANCE_TYPE ((object), CDOS_TYPE_WINDOW_TRACKER))
#define CDOS_IS_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_WINDOW_TRACKER))
#define CDOS_WINDOW_TRACKER_GET_CLASS(obj)                                                                             \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_WINDOW_TRACKER, CdosWindowTrackerClass))

struct _CdosWindowTrackerClass
{
    GObjectClass parent_class;
};

GType cdos_window_tracker_get_type (void) G_GNUC_CONST;

CdosWindowTracker *cdos_window_tracker_get_default (void);

CdosApp *cdos_window_tracker_get_window_app (CdosWindowTracker *tracker, MetaWindow *metawin);

CdosApp *cdos_window_tracker_get_app_from_pid (CdosWindowTracker *tracker, int pid);

gboolean cdos_window_tracker_is_window_interesting (MetaWindow *window);

const char *_cdos_window_tracker_get_app_context (CdosWindowTracker *tracker, CdosApp *app);

GSList *cdos_window_tracker_get_startup_sequences (CdosWindowTracker *tracker);

CdosApp *cdos_window_tracker_get_focus_app (CdosWindowTracker *tracker);

G_END_DECLS

#endif /* __CDOS_WINDOW_TRACKER_H__ */
