/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_WM_PRIVATE_H__
#define __CDOS_WM_PRIVATE_H__

#include "cdos-wm.h"

G_BEGIN_DECLS

/* These forward along the different effects from CdosPlugin */

void _cdos_base_wm_minimize (CdosBaseWM *wm, MetaWindowActor *actor);
void _cdos_base_wm_unminimize (CdosBaseWM *wm, MetaWindowActor *actor);
void _cdos_base_wm_size_change (CdosBaseWM *wm,
                                MetaWindowActor *actor,
                                MetaSizeChange which_change,
                                MetaRectangle *old_frame_rect,
                                MetaRectangle *old_buffer_rect);
void _cdos_base_wm_show_tile_workspace (CdosBaseWM *wm, MetaWindowActor *actor);
void _cdos_base_wm_show_tile_preview (CdosBaseWM *wm, MetaWindow *window, MetaRectangle *tile_rect, int tile_monitor);
void _cdos_base_wm_hide_tile_preview (CdosBaseWM *wm);
void _cdos_base_wm_map (CdosBaseWM *wm, MetaWindowActor *actor);
void _cdos_base_wm_destroy (CdosBaseWM *wm, MetaWindowActor *actor);

void _cdos_base_wm_switch_workspace (CdosBaseWM *wm, gint from, gint to, MetaMotionDirection direction);
void _cdos_base_wm_kill_window_effects (CdosBaseWM *wm, MetaWindowActor *actor);
void _cdos_base_wm_kill_switch_workspace (CdosBaseWM *wm);
void _cdos_base_wm_show_window_menu (CdosBaseWM *wm, MetaWindow *window, MetaWindowMenuType menu, int x, int y);

void _cdos_base_wm_show_window_menu_for_rect (CdosBaseWM *wm,
                                              MetaWindow *window,
                                              MetaWindowMenuType menu,
                                              MetaRectangle *rect);

gboolean _cdos_base_wm_filter_keybinding (CdosBaseWM *wm, MetaKeyBinding *binding);
void _cdos_base_wm_confirm_display_change (CdosBaseWM *wm);

G_END_DECLS

#endif /* __CDOS_WM_PRIVATE_H__ */
