/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_BASE_WM_H__
#define __CDOS_BASE_WM_H__

#include <glib-object.h>
#include <meta/meta-plugin.h>

G_BEGIN_DECLS

typedef struct _CdosBaseWM CdosBaseWM;
typedef struct _CdosBaseWMClass CdosBaseWMClass;

#define CDOS_TYPE_BASE_WM (cdos_base_wm_get_type ())
#define CDOS_BASE_WM(object) (G_TYPE_CHECK_INSTANCE_CAST ((object), CDOS_TYPE_BASE_WM, CdosBaseWM))
#define CDOS_BASE_WM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_BASE_WM, CdosBaseWMClass))
#define CDOS_IS_BASE_WM(object) (G_TYPE_CHECK_INSTANCE_TYPE ((object), CDOS_TYPE_BASE_WM))
#define CDOS_IS_BASE_WM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_BASE_WM))
#define CDOS_BASE_WM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_BASE_WM, CdosBaseWMClass))

struct _CdosBaseWMClass
{
    GObjectClass parent_class;
};

GType cdos_base_wm_get_type (void) G_GNUC_CONST;

CdosBaseWM *cdos_base_wm_new (MetaPlugin *plugin);

void cdos_base_wm_completed_minimize (CdosBaseWM *wm, MetaWindowActor *actor);
void cdos_base_wm_completed_unminimize (CdosBaseWM *wm, MetaWindowActor *actor);
void cdos_base_wm_completed_size_change (CdosBaseWM *wm, MetaWindowActor *actor);
void cdos_base_wm_completed_display_change (CdosBaseWM *wm, gboolean ok);
void cdos_base_wm_completed_map (CdosBaseWM *wm, MetaWindowActor *actor);
void cdos_base_wm_completed_destroy (CdosBaseWM *wm, MetaWindowActor *actor);
void cdos_base_wm_completed_switch_workspace (CdosBaseWM *wm);

MetaPlugin *cdos_base_wm_get_plugin (CdosBaseWM *wm);

G_END_DECLS

#endif /* __CDOS_BASE_WM_H__ */
