/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __ST_ICON_COLORS__
#define __ST_ICON_COLORS__

#include <clutter/clutter.h>

G_BEGIN_DECLS

#define ST_TYPE_ICON_COLORS (st_icon_colors_get_type ())

typedef struct _StIconColors StIconColors;

/**
 * StIconColors:
 * @foreground: 前景色
 * @warning: 指示警告状态的颜色
 * @error: 指示错误状态的颜色
 * @success: 指示成功嗯操作的颜色
 *
 * StIconColors结构体囊括为指定icon着色的颜色。
 */
struct _StIconColors {
  volatile guint ref_count;

  ClutterColor foreground;
  ClutterColor warning;
  ClutterColor error;
  ClutterColor success;
};

GType     st_icon_colors_get_type (void) G_GNUC_CONST;

StIconColors *st_icon_colors_new   (void);
StIconColors *st_icon_colors_ref   (StIconColors *colors);
void          st_icon_colors_unref (StIconColors *colors);
StIconColors *st_icon_colors_copy  (StIconColors *colors);
gboolean      st_icon_colors_equal (StIconColors *colors,
                                    StIconColors *other);

G_END_DECLS

#endif /* __ST_ICON_COLORS__ */
