/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
/*
 * st-tooltip.h: Plain tooltip actor
 *
 * Copyright 2008, 2009 Intel Corporation.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU Lesser General Public License,
 * version 2.1, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
 * more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#if !defined(ST_H_INSIDE) && !defined(ST_COMPILATION)
#error "Only <st/st.h> can be included directly.h"
#endif

#ifndef __ST_TOOLTIP_H__
#define __ST_TOOLTIP_H__

G_BEGIN_DECLS

#include <st/st-bin.h>

#define ST_TYPE_TOOLTIP                (st_tooltip_get_type ())
G_DECLARE_DERIVABLE_TYPE (StTooltip, st_tooltip, ST, TOOLTIP, StWidget)

typedef struct _StTooltipClass         StTooltipClass;

struct _StTooltipClass
{
  StWidgetClass parent_class;
};

const gchar * st_tooltip_get_label (StTooltip   *tooltip);
void          st_tooltip_set_label (StTooltip   *tooltip,
                                    const gchar *text);

void           st_tooltip_set_source (StTooltip     *tooltip,
                                      ClutterActor  *actor);
ClutterActor * st_tooltip_get_source (StTooltip     *tooltip);

/**
 * StTooltipConstrainFunc:
 * @tooltip: StTooltip对象
 * @geometry: 没有任何约束的tooltip的大小和位置
 * @adjusted_geometry: (out): tooltip的新位置。宽度和高度值被忽略。
 * @data: (closure): 传递给st_tooltip_set_constrain_func()的用户数据
 */
typedef void (*StTooltipConstrainFunc) (StTooltip             *tooltip,
                                        const graphene_rect_t *geometry,
                                        graphene_rect_t       *adjusted_geometry,
                                        gpointer               data);

void st_tooltip_set_constrain_func (ClutterStage           *stage,
                                    StTooltipConstrainFunc  func,
                                    gpointer                data,
                                    GDestroyNotify          notify);

G_END_DECLS

#endif /* __ST_TOOLTIP_H__ */
