#ifndef __CODS_APP_FAVORITES_H__
#define __CDOS_APP_FAVORITES_H__

#include "st.h"

G_BEGIN_DECLS

#define CDOS_TYPE_APP_FAVORITES (cdos_app_favorites_get_type ())

#define CDOS_APP_FAVORITES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_APP_FAVORITES, CdosAppFavorites))

#define CDOS_IS_APP_FAVORITES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_APP_FAVORITES))

#define CDOS_APP_FAVORITES_CLASS(klass)                                                                                \
    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_APP_FAVORITES, CdosAppFavoritesClass))

#define CDOS_IS_APP_FAVORITES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_APP_FAVORITES))

#define CDOS_APP_FAVORITES_GET_CLASS(obj)                                                                              \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_APP_FAVORITES, CdosAppFavoritesClass))

typedef struct _CdosAppFavorites CdosAppFavorites;
typedef struct _CdosAppFavoritesPrivate CdosAppFavoritesPrivate;
typedef struct _CdosAppFavoritesClass CdosAppFavoritesClass;


struct _CdosAppFavorites
{
    GObject parent_instance;

    CdosAppFavoritesPrivate *priv;
};

struct _CdosAppFavoritesClass
{
    GObjectClass parent_class;
    void (*changed) (CdosAppFavorites *app);
};

GType cdos_app_favorites_get_type (void) G_GNUC_CONST;

GHashTable *cdos_app_favorites_get_favorites_map (CdosAppFavorites *app);

GList *cdos_app_favorites_get_favorites (CdosAppFavorites *app);

gboolean cdos_app_favorites_is_favorite (CdosAppFavorites *app, const gchar *appId);

void cdos_app_favorites_add_favorite (CdosAppFavorites *app, gchar *appId, gint pos);

void cdos_app_favorites_add_favorite_to_pos (CdosAppFavorites *app, gchar *appId, gint pos);

void cdos_app_favorites_move_favorite_to_pos (CdosAppFavorites *app, gchar *appId, gint pos);

void cdos_app_favorites_remove_favorite (CdosAppFavorites *app, gchar *appId);

CdosAppFavorites *cdos_app_favorites_get_default (void);

G_END_DECLS

#endif /*_CDOS_APP_FAVORITES_H_*/
