#ifndef __CDOS_APPLET_MANAGER_H__
#define __CDOS_APPLET_MANAGER_H__

#include <glib.h>
#include "cdos-applet.h"

G_BEGIN_DECLS

/**
 * An applet can assume a role
 * Instead of hardcoding looking for particular applet
 * We let applets announce that they can fill a particular
 * role, using the 'role' metadata entry.
 * For now, just notifications, but could be expaned.
 * question - should multiple applets be able to fill
 * the same role?
 */
#define CDOS_APPLET_MANAGER_NOTIFICATIONS "nitifications"
#define CDOS_APPLET_MANAGER_WINDOW_LIST "windowlist"

typedef struct _AppletDefinition AppletDefinition;

void cdos_applet_manager_init (void);

gboolean cdos_applet_manager_finish_extension_load (CdosExtension *extension);

void
cdos_applet_manager_remove_applet_from_panel (CdosApplet *obj, gchar *event,
                                              gchar *keep_menu, const gchar *uuid);

void cdos_applet_manager_save_applets_positions (void);

void cdos_applet_manager_add_applet_to_panel (CdosExtension *extension);

void cdos_applet_manager_set_applets_orientation (StSide orientation);

G_END_DECLS
#endif /* __CDOS_APPLET_MANAGER_H__ */
