#ifndef __APP_SWITCHER_3D_H__
#define __APP_SWITCHER_3D_H__

#include "cdos-appswitcher-private.h"
#include "cdos-appswitcher.h"
#include "cdos-background.h"

typedef struct _AppSwitcher3D AppSwitcher3D;

struct _AppSwitcher3D {
    AppSwitcher parent;

    ClutterActor *window_title;
    ClutterActor *icon;
    ClutterActor *application_icon_box;
    long          last_time;

    CdosBackgroundManager *background;
    ClutterActor *background_group;

    ClutterActor *preview_actor;

    /* hash table 保存target_height, target_width, 及preview.metaWindow */
    GHashTable   *preview_table;

    gboolean monitor_fix;
    gfloat   old_width;
    gfloat   old_height;
};

void cdos_appswitcher3d_init (AppSwitcher3D *self, MetaKeyBinding *binding);

typedef struct _PreviewData {
    gfloat target_width;
    gfloat target_height;
    gfloat target_width_side;
    gfloat target_height_side;
    MetaWindow *meta_window;
}PreviewData;

#endif // __APP_SWITCHER_3D_H__
