#ifndef __CDOS_APPSWITCHER_H__
#define __CDOS_APPSWITCHER_H__

#include "cdos-types.h"

#include <meta/keybindings.h>

/**
 * SECTION: cdos-appswitcher
 * @Title: AppSwitcher
 * @short-description: 切换应用程序
 *
 * 在应用程序及工作区间进行切换，关闭窗口、显示桌面
 */
typedef struct _AppSwitcher AppSwitcher;

/**
 * FilterFunc:
 * @data: glist element data
 *
 * 用于 g_list_filter(), 根据返回结果判断是否删除节点。
 *
 * Returns: 返回 0,不需要该节点，否则不过滤掉。
 */
typedef int (*FilterFunc) (void *data);

/**
 * FilterFunc_p:
 * @data: glist element data
 * @ptr: user data
 *
 * 用于 g_list_filter_p(), 根据返回结果判断是否删除节点。
 *
 * Returns: 返回 0,不需要该节点，否则不过滤掉。
 */
typedef int (*FilterFunc_p) (void *data, const void *ptr);

GList *g_list_filter (const GList *list, FilterFunc filter_func);

GList *g_list_filter_p (const GList *list, FilterFunc_p filter_func, const void *data);

GList *cdos_get_windows_for_binding (MetaKeyBinding *binding);

#endif // __UI_APPSWITCHER_H__
