#ifndef __CDOS_AUTO_MOUNT_MANAGER_H__
#define __CDOS_AUTO_MOUNT_MANAGER_H__

#include <glib-object.h>
#include <gio/gio.h>

#include "cdos-console-kit-manager.h"
#include "cdos-screen-saver.h"

GType cdos_auto_mount_manager_get_type (void);

#define CDOS_TYPE_AUTO_MOUNT_MANAGER (cdos_auto_mount_manager_get_type ())
#define CDOS_AUTO_MOUNT_MANAGER(obj)                                                                                   \
    (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_AUTO_MOUNT_MANAGER, CdosAutoMountManager))
#define CDOS_IS_AUTO_MOUNT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_AUTO_MOUNT_MANAGER))
#define CDOS_AUTO_MOUNT_MANAGER_CLASS(klass)                                                                           \
    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_AUTO_MOUNT_MANAGER, CdosAutoMountManagerClass))
#define CDOS_IS_AUTO_MOUNT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_AUTO_MOUNT_MANAGER))
#define CDOS_AUTO_MOUNT_MANAGER_GET_CLASS(obj)                                                                         \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_AUTO_MOUNT_MANAGER, CdosAutoMountManagerClass))

typedef struct _CdosAutoMountManager CdosAutoMountManager;
typedef struct _CdosAutoMountManagerClass CdosAutoMountManagerClass;


struct _CdosAutoMountManagerClass
{
    GObjectClass parent_class;
};

struct _CdosAutoMountManager
{
    GObject parent_instance;

    GSettings *settings;
    GList *volumeQueue;
    CdosConsoleKitManager *ckListener;
    CdosScreenSaver *ss_proxy;
    GVolumeMonitor *volumeMonitor;
    gboolean is_active;
};

CdosAutoMountManager *cdos_auto_mount_manager_new (void);

#endif
