#ifndef __CDOS_BACKGROUND_H__
#define __CDOS_BACKGROUND_H__
#include <fd.h>
#include <clutter/clutter.h>
#include <meta/meta-background.h>
#include <meta/meta-background-image.h>
#include <meta/meta-background-actor.h>

typedef struct _CdosBackground CdosBackground;

struct _CdosBackground
{
    MetaDisplay *display;
    gulong changed_id;
    ClutterActor *container;
    FdBgSettings *settings;
    GDesktopBackgroundStyle style;
    gboolean vignette;
    guint monitor_index;
    gboolean control_position;
    MetaBackground *meta_background;
    MetaBackgroundImageCache *cache;
    ClutterActor *actor;
    GFile *file1;
    GFile *file2;
    MetaBackgroundImage *image1;
    MetaBackgroundImage *image2;
    gchar *picture_uri;
    guint duration;
    GDir *dir;
    ClutterTimeline *timeline;
    gulong monitor_changed_id;
    gulong settings_changed_id;
    guint animation_timeout_id;
    gboolean use_animation;
    gboolean is_default;
    
    ClutterActor *watermark;
    gint register_status;
    GDBusProxy *register_proxy;
    GCancellable *cancellable;
    gboolean check_flags;       //标志registered_status状态改变后，是否设置未激活壁纸
    guint check_registe_status_id;
    gchar *register_name;
};

CdosBackground *cdos_background_new (ClutterActor *container,
                                     guint monitor_index,
                                     gboolean vignette,
                                     gboolean control_position,
                                     gboolean ignore_licenses,
                                     const gchar *settings_schema);

void cdos_background_destroy (CdosBackground *self);


typedef struct _CdosBackgroundManager CdosBackgroundManager;

CdosBackgroundManager *cdos_background_manager_new (ClutterActor *container,
                                                    gboolean vignette,
                                                    gboolean control_position,
                                                    gboolean ignore_licenses,
                                                    const gchar *settings_schema);

void cdos_background_manager_hide_register_watermark (CdosBackgroundManager *self);

void cdos_background_manager_destroy (CdosBackgroundManager *self);

#endif
