#ifndef __CDOS_BOX_POINTER_H__
#define __CDOS_BOX_POINTER_H__

#include <glib-object.h>
#include <gdk/gdk.h>
#include <clutter/clutter.h>
#include <cairo.h>
#include "st.h"
#include "cdos-global.h"
#include <meta/display.h>
#include <meta/util.h>

G_BEGIN_DECLS

#define CDOS_TYPE_BOX_POINTER                   (cdos_box_pointer_get_type ())
#define CDOS_BOX_POINTER(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_BOX_POINTER, CdosBoxPointer))
#define CDOS_IS_BOX_POINTER(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_BOX_POINTER))
#define CDOS_BOX_POINTER_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_BOX_POINTER, CdosBoxPointerClass))
#define CDOS_IS_BOX_POINTER_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_BOX_POINTER))
#define CDOS_BOX_POINTER_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_BOX_POINTER, CdosBoxPointerClass))
typedef struct _CdosBoxPointer CdosBoxPointer;
typedef struct _CdosBoxPointerPrivate CdosBoxPointerPrivate;
typedef struct _CdosBoxPointerClass CdosBoxPointerClass;

struct _CdosBoxPointer 
{
    StWidget parent;

    StBin *bin;
    StDrawingArea *border;
    CdosBoxPointerPrivate *priv;
};

struct _CdosBoxPointerClass 
{
    StWidgetClass parent_class;
};

GType cdos_box_pointer_get_type (void) G_GNUC_CONST;

CdosBoxPointer *cdos_box_pointer_new (gint arrow_side);

void cdos_box_pointer_set_x_position (CdosBoxPointer *self, const gfloat position);

void cdos_box_pointer_set_y_position (CdosBoxPointer *self, const gfloat position);

void cdos_box_pointer_show (CdosBoxPointer *self, gboolean animate);

void cdos_box_pointer_hide (CdosBoxPointer *self, gboolean animate);

void cdos_box_pointer_set_arrow_side (CdosBoxPointer *self, StSide side);

gboolean cdos_box_pointer_set_position (CdosBoxPointer *self, 
                                        ClutterActor *sourceActor,
                                        gfloat alignment);

void cdos_box_pointer_set_position_x_y (CdosBoxPointer *self,
                                        ClutterActor *source_actor, 
                                        gfloat alignment, 
                                        gfloat x, 
                                        gfloat y);

void cdos_box_pointer_set_source_alignment (CdosBoxPointer *self, gfloat alignment);

void cdos_box_pointer_set_arrow_origin (CdosBoxPointer *self, gfloat origin);

gdouble cdos_box_pointer_get_arrow_origin (CdosBoxPointer *self);

G_END_DECLS
#endif /* __CDOS_BOX_POINTER_H__ */
