#ifndef __CDOS_DOC_INFO_H__
#define __CDOS_DOC_INFO_H__

#include <glib.h>
#include "st.h"

#define CDOS_TYPE_DOC_INFO (cdos_doc_info_get_type ())
#define CDOS_DOC_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_DOC_INFO, CdosDocInfo))
#define CDOS_DOC_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_DOC_INFO, CdosDocInfoClass))
#define CDOS_IS_DOC_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_DOC_INFO))
#define CDOS_IS_DOC_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_DOC_INFO))
#define CDOS_DOC_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_DOC_INFO, CdosDocInfoClass))

typedef struct _CdosDocInfo CdosDocInfo;
typedef struct _CdosDocInfoClass CdosDocInfoClass;
typedef struct _CdosDocInfoPrivate CdosDocInfoPrivate;

struct _CdosDocInfo
{
    GObject parent;

    CdosDocInfoPrivate *priv;
};

struct _CdosDocInfoClass
{
    GObjectClass parent_class;
};

// clang-format off
typedef enum {
    NONE = 0,
    SUBSTRING,
    MULTIPLE_SUBSTRING,
    PREFIX,
    MULTIPLE_PREFIX
} MATCHTYPE;
// clang-format on

GType cdos_doc_info_get_type (void) G_GNUC_CONST;

CdosDocInfo *cdos_doc_info_new (GtkRecentInfo *recent_info);

CdosDocInfo *cdos_doc_info_set_params (CdosDocInfo *info, GtkRecentInfo *recent_info);

const gchar *cdos_doc_info_get_uri (CdosDocInfo *info);

ClutterActor *cdos_doc_info_create_icon (CdosDocInfo *info, gint size);

void cdos_doc_info_launch (CdosDocInfo *info);

gint cdos_doc_info_match_terms (CdosDocInfo *info, GList *terms);

gchar *cdos_doc_info_get_name (CdosDocInfo *info);


#endif /* __CDOS_DOC_INFO_H__ */
