#ifndef __CDOS_DOC_MANAGER_H__
#define __CDOS_DOC_MANAGER_H__

#include <glib.h>
#include "st.h"
#include "cdos-doc-info.h"

#define CDOS_TYPE_DOC_MANAGER (cdos_doc_manager_get_type ())
#define CDOS_DOC_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_DOC_MANAGER, CdosDocManager))
#define CDOS_DOC_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_DOC_MANAGER, CdosDocManagerClass))
#define CDOS_IS_DOC_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_DOC_MANAGER))
#define CDOS_IS_DOC_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_DOC_MANAGER))
#define CDOS_DOC_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_DOC_MANAGER, CdosDocManagerClass))

typedef struct _CdosDocManager CdosDocManager;
typedef struct _CdosDocManagerClass CdosDocManagerClass;
typedef struct _CdosDocManagerPrivate CdosDocManagerPrivate;

struct _CdosDocManager
{
    GObject parent;

    CdosDocManagerPrivate *priv;
};

struct _CdosDocManagerClass
{
    GObjectClass parent_class;
    void (*changed) (CdosDocManager *manager);
};

GType cdos_doc_manager_get_type (void) G_GNUC_CONST;

CdosDocManager *cdos_doc_manager_get_default (void);

GList *cdos_doc_manager_get_time_stamp_ordered_infos (CdosDocManager *manager);

GHashTable *cdos_doc_manager_get_infos_by_uri (CdosDocManager *manager);

CdosDocInfo *cdos_doc_manager_lookup_by_uri (CdosDocManager *manager, const gchar *uri);

#endif /* __CDOS_DOC_MANAGER_H__ */
