/*
 * Author:
 *   leit <leitong@cpu-os.ac.cn>
 *
 * Created:
 *   2017年11月28日 10时38分15秒
 */
#ifndef __CDOS_DRAG_DROP_H__
#define __CDOS_DRAG_DROP_H__

#include <clutter/clutter.h>

extern gboolean drag_drop_successfull;

ClutterAction *cdos_drag_action_new (ClutterActor *actor);

ClutterAction *cdos_drag_action_new_with_handle (ClutterActor *actor, ClutterActor *handle);

ClutterDragAction *cdos_get_current_drag_action (void);

void cdos_set_current_drag_action (ClutterDragAction *action);

#define CDOS_TYPE_DROP_ACTION                       (cdos_drop_action_get_type ())
#define CDOS_DROP_ACTION(obj)                       (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_DROP_ACTION, CdosDropAction))
#define CDOS_DROP_ACTION_CLASS(klass)               (G_TYPE_CHECK_CLASS_CAST ((obj), CDOS_TYPE_DROP_ACTION))

typedef struct _CdosDropAction          CdosDropAction;
typedef struct _CdosDropActionPrivate   CdosDropActionPrivate;
typedef struct _CdosDropActionClass     CdosDropActionClass;

struct _CdosDropAction
{
    ClutterAction parent_instance;
    CdosDropActionPrivate *priv;
};

struct _CdosDropActionClass
{
    ClutterActionClass parent_class;

    /*< public >*/
    gboolean (* can_drop) (CdosDropAction *action,
                           ClutterActor      *actor,
                           gfloat             event_x,
                           gfloat             event_y);

    void     (* over_in)  (CdosDropAction *action,
                           ClutterActor      *actor);
    void     (* over_out) (CdosDropAction *action,
                           ClutterActor      *actor);

    void     (* drop)     (CdosDropAction *action,
                           ClutterActor      *actor,
                           gfloat             event_x,
                           gfloat             event_y);
};

GType cdos_drop_action_get_type (void) G_GNUC_CONST;

ClutterAction *cdos_drop_action_new (ClutterActor *actor);

#endif // __CDOS_DRAG_DROP_H__
