#ifndef __CDOS_ICON_DISPATCHER_H__
#define __CDOS_ICON_DISPATCHER_H__

#include "cdos-tray-manager.h"
#include "cdos-tray-icon.h"
#include "cdos-panel.h"
#include "cdos-global.h"

#define CDOS_TYPE_ICON_DISPATCHER                (cdos_icon_dispatcher_get_type ())
#define CDOS_ICON_DISPATCHER(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_ICON_DISPATCHER, CdosIconDispatcher))
#define CDOS_IS_ICON_DISPATCHER(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_ICON_DISPATCHER))
#define CDOS_ICON_DISPATCHER_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_ICON_DISPATCHER, CdosIconDispatcherClass))
#define CDOS_IS_ICON_DISPATCHER_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_ICON_DISPATCHER))
#define CDOS_ICON_DISPATCHER_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_ICON_DISPATCHER, CdosIconDispatcherClass))

typedef struct _CdosIconDispatcher CdosIconDispatcher;
typedef struct _CdosIconDispatcherPrivate CdosIconDispatcherPrivate;
typedef struct _CdosIconDispatcherClass CdosIconDispatcherClass;

struct _CdosIconDispatcher
{
    GObject parent_instance;

    CdosTrayManager *traymanager;
};

struct _CdosIconDispatcherClass
{
    GObjectClass parent_class;

    /* signals */

    void (*status_icon_added) (CdosIconDispatcher *manager, CdosTrayIcon *icon, gchar *role);
    void (*status_icon_removed) (CdosIconDispatcher *manager, CdosTrayIcon *icon);

    void (*message_icon_added) (CdosIconDispatcher *manager, CdosTrayIcon *icon);
    void (*message_icon_removed) (CdosIconDispatcher *manager, CdosTrayIcon *icon);

    void (*before_redisplay) (CdosIconDispatcher *manager);
    void (*after_redisplay) (CdosIconDispatcher *manager);
};

GType cdos_icon_dispatcher_get_type (void);

CdosIconDispatcher *cdos_icon_dispatcher_new (void);

CdosIconDispatcher *cdos_icon_dispatcher_get (void);

void cdos_icon_dispatcher_start (CdosIconDispatcher *self, CdosPanel *panel);

void cdos_icon_dispatcher_redisplay (CdosIconDispatcher *dispatcher);

#endif
