#ifndef __CDOS_KEYBINDINGS_H__
#define __CDOS_KEYBINDINGS_H__ 

#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <meta/display.h>

#include "cdos-global.h"

#define CDOS_TYPE_KEYBINDINGS (cdos_keybindings_get_type ())
G_DECLARE_FINAL_TYPE (CdosKeybindings, cdos_keybindings, CDOS, KEYBINDINGS, GObject)


gboolean cdos_keybindings_add_hot_key (CdosKeybindings *keybindings,
                                       gchar *name, 
                                       gchar *binding, 
                                       MetaKeyHandlerFunc callback,
                                       gpointer user_data,
                                       GDestroyNotify free_data);
                                                  
CdosKeybindings *cdos_keybindings_new (void);

gboolean cdos_keybindings_allow_keybinding (CdosKeybindings *self, const char *key);


CdosActionMode  cdos_get_action_mode (void);
void            cdos_set_action_mode (CdosActionMode);

#endif /* __CDOS_KEYBINDING_MANAGER_H__ */
