/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __CDOS_KEYBOARD_MANAGER_H__
#define __CDOS_KEYBOARD_MANAGER_H__

#include <glib.h>
#include <clutter/clutter.h>

G_BEGIN_DECLS

#define CDOS_TYPE_KEYBOARD_MANAGER (cdos_keyboard_manager_get_type ())

G_DECLARE_FINAL_TYPE (CdosKeyboardManager, cdos_keyboard_manager, CDOS, KEYBOARD_MANAGER, GObject)

CdosKeyboardManager *cdos_keyboard_manager_new (void);

CdosKeyboardManager *cdos_keyboard_manager_get (void);

gboolean cdos_keyboard_manager_should_take_event (CdosKeyboardManager *self,
                                                  ClutterEvent *event);

gboolean cdos_keyboard_manager_get_im_focused (CdosKeyboardManager *self);

void cdos_keyboard_manager_keyval_press (CdosKeyboardManager *self, guint keyval);

void cdos_keyboard_manager_keyval_release (CdosKeyboardManager *self, guint keyval);

G_END_DECLS

#endif // __CDOS_KEYBOARD_MANAGER_H__
