#ifndef __CDOS_LOGIN_MANAGER_H__
#define __CDOS_LOGIN_MANAGER_H__

#include <glib-object.h>

#define CDOS_TYPE_LOGIN_MANAGER (cdos_login_manager_get_type ())
G_DECLARE_FINAL_TYPE (CdosLoginManager, cdos_login_manager, CDOS, LOGIN_MANAGER, GObject)

CdosLoginManager *cdos_login_manager_new (void);

/*
 * na: the operation is not available because hardware,
 * kernel, or drivers do not support it.
 *
 * yes: the operation is supported and the user may
 * execute the operation without further authentication.
 *
 * no: the operation is available but the user is not
 * allowed to execute the operation.
 *
 * challenge: the operation is available but only after authorization.
 **/
typedef enum
{
    CDOS_LOGIN1_RESULT_NA,
    CDOS_LOGIN1_RESULT_YES,
    CDOS_LOGIN1_RESULT_NO,
    CDOS_LOGIN1_RESULT_CHALLENGE
}CdosLogin1Result;

typedef void (*CdosLogin1Callback) (gpointer user_data, CdosLogin1Result result);

void cdos_login_manager_can_halt         (CdosLoginManager *self, CdosLogin1Callback callback, gpointer user_data);
void cdos_login_manager_can_hibernate    (CdosLoginManager *self, CdosLogin1Callback callback, gpointer user_data);
void cdos_login_manager_can_hybrid_sleep (CdosLoginManager *self, CdosLogin1Callback callback, gpointer user_data);
void cdos_login_manager_can_power_off    (CdosLoginManager *self, CdosLogin1Callback callback, gpointer user_data);
void cdos_login_manager_can_reboot       (CdosLoginManager *self, CdosLogin1Callback callback, gpointer user_data);
void cdos_login_manager_can_suspend      (CdosLoginManager *self, CdosLogin1Callback callback, gpointer user_data);

void cdos_login_manager_halt         (CdosLoginManager *self, gboolean interactive);
void cdos_login_manager_hibernate    (CdosLoginManager *self, gboolean interactive);
void cdos_login_manager_hybrid_sleep (CdosLoginManager *self, gboolean interactive);
void cdos_login_manager_power_off    (CdosLoginManager *self, gboolean interactive);
void cdos_login_manager_reboot       (CdosLoginManager *self, gboolean interactive);
void cdos_login_manager_suspend      (CdosLoginManager *self, gboolean interactive);

#endif
