/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
#ifndef __CDOS_MAGNIFIER_H__
#define __CDOS_MAGNIFIER_H__

#include "cdos-global.h"

GType cdos_magnifier_get_type (void);

#define CDOS_TYPE_MAGNIFIER                (cdos_magnifier_get_type ())
#define CDOS_MAGNIFIER(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_MAGNIFIER, CdosMagnifier))
#define CDOS_IS_MAGNIFIER(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_MAGNIFIER))
#define CDOS_MAGNIFIER_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_MAGNIFIER, CdosMagnifierClass))
#define CDOS_IS_MAGNIFIER_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_MAGNIFIER))
#define CDOS_MAGNIFIER_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_MAGNIFIER, CdosMagnifierClass))

typedef struct _CdosMagnifier              CdosMagnifier;
typedef struct _CdosMagnifierPrivate       CdosMagnifierPrivate;
typedef struct _CdosMagnifierClass         CdosMagnifierClass;

struct _CdosMagnifier
{
    GObject *parent_instance;

    GList *zoom_regions;
    gboolean enabled;
    GSettings *settings;
    GSettings *zoom_settings;

    MetaCursorTracker *cursor_tracker;
    gint x_mouse;
    gint y_mouse;

    guint mouse_tracking_id;
    guint cursor_tracker_id;
    CdosMagnifierPrivate *priv;
};

struct _CdosMagnifierClass
{
  GObjectClass parent_class;

};

CdosMagnifier *cdos_magnifier_new (void);
void cdos_magnifier_hide_system_cursor (CdosMagnifier *self);

#endif /* __CDOS_MAGNIFIER_H__ */
