/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *
 * This software is published by the license of CPU-OS License，you can use and
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us
 * by email <support_os@cpu-os.ac.cn>
 *
 **/
#ifndef __CDOS_MESSAGE_DIALOG_H__
#define __CDOS_MESSAGE_DIALOG_H__

#include <glib-object.h>
#include <gio/gio.h>

#include "st.h"

typedef enum _CdosResponseType
{
    CDOS_RESPONSE_NONE,
    CDOS_RESPONSE_OK,
    CDOS_RESPONSE_CANCEL,
    CDOS_RESPONSE_CLOSE,
    CDOS_RESPONSE_YES,
    CDOS_RESPONSE_NO,
    CDOS_RESPONSE_APPLY
}CdosResponseType;

#define CDOS_TYPE_MESSAGE_DIALOG (cdos_message_dialog_get_type ())

G_DECLARE_FINAL_TYPE (CdosMessageDialog, cdos_message_dialog, CDOS, MESSAGE_DIALOG, StBoxLayout)

CdosMessageDialog *cdos_message_dialog_new (const gchar *title,
                                            const gchar *message);

CdosMessageDialog *cdos_message_dialog_new_with_buttons (const gchar *title,
                                                         const gchar *message,
                                                         GCallback callback,
                                                         gpointer user_data);

StWidget *cdos_message_dialog_add_button (CdosMessageDialog *self,
                                          const char *label,
                                          CdosResponseType response_id);

void cdos_message_dialog_set_title (CdosMessageDialog *self,
                                    const gchar *title);

void cdos_message_dialog_set_message (CdosMessageDialog *self,
                                      const gchar *message);

void cdos_message_dialog_set_icon_name (CdosMessageDialog *self,
                                        const gchar *icon);

void cdos_message_dialog_set_callback (CdosMessageDialog *self,
                                       GCallback callback,
                                       gpointer user_data);

#endif
