/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
/**
 * Class that handle messageTray
 * Inherits: #CdosMessageTray
 */
#ifndef __CDOS_MESSAGE_TRAY_H__
#define __CDOS_MESSAGE_TRAY_H__

#include "cdos-source.h"
#include "cdos-session.h"

#define CDOS_TYPE_MESSAGE_TRAY		(cdos_message_tray_get_type ())
#define CDOS_MESSAGE_TRAY(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_MESSAGE_TRAY, CdosMessageTray))
#define CDOS_IS_MESSAGE_TRAY(obj)           	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_MESSAGE_TRAY))
#define CDOS_MESSAGE_TRAY_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_MESSAGE_TRAY, CdosMessageTrayClass))
#define CDOS_IS_MESSAGE_TRAY_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_MESSAGE_TRAY))
#define CDOS_MESSAGE_TRAY_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_MESSAGE_TRAY, CdosMessageTrayClass))

typedef struct _CdosMessageTray		CdosMessageTray;
typedef struct _CdosMessageTrayClass	CdosMessageTrayClass;

struct _CdosMessageTray
{
	StWidget parent_instance;

	GQueue *notification_queue;
	CdosNotification *notification;
	gulong notification_clicked_id;

	guint notification_state;

	guint notification_timeout_id;
	gulong notification_expanded_id;
	gboolean notification_removed;

	GList *sources;  //包含CdosSource的list
    gfloat x;

	gboolean notifications_enabled;
    gboolean dnd;
};

struct _CdosMessageTrayClass
{
    StWidgetClass parent_class;
};

GType cdos_message_tray_get_type (void);

gboolean cdos_message_tray_contains (CdosMessageTray *self, CdosSource *source);

void cdos_message_tray_add (CdosMessageTray *self, CdosSource *source);

void cdos_message_tray_toggle (CdosMessageTray *self);

void cdos_message_tray_hide (CdosMessageTray *self);

CdosMessageTray *cdos_message_tray_get_default (void);

void cdos_message_tray_want_send_to_applet (gboolean willSend);
void cdos_message_tray_set_dnd (CdosMessageTray *self, gboolean dnd);

#endif
