/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
/*
 * Created by cdos on 16-3-30.
 */
#ifndef __CDOS_NOTIFICATION_DAEMON_H__
#define __CDOS_NOTIFICATION_DAEMON_H__

#include "cdos-notification.h"
#include <gio/gio.h> /*BUS define*/

#define CDOS_TYPE_NOTIFICATION_DAEMON    (cdos_notification_daemon_get_type ())
#define CDOS_NOTIFICATION_DAEMON(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_NOTIFICATION_DAEMON, CdosNotificationDaemon))
#define CDOS_IS_NOTIFICATION_DAEMON(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_NOTIFICATION_DAEMON))
#define CDOS_NOTIFICATION_DAEMON_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_NOTIFICATION_DAEMON, CdosNotificationDaemonClass))
#define CDOS_IS_NOTIFICATION_DAEMON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_NOTIFICATION_DAEMON))
#define CDOS_NOTIFICATION_DAEMON_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_NOTIFICATION_DAEMON, CdosNotificationDaemonClass))

typedef struct _CdosNotificationDaemon CdosNotificationDaemon;
typedef struct _CdosNotificationDaemonClass CdosNotificationDaemonClass;

struct _CdosNotificationDaemon
{
    GObject parent_instance;

    GDBusProxy *bus_proxy;
    GDBusNodeInfo* notification_node_info;
    GList *sources;
    GHashTable *sender_to_pid;
    GHashTable *notifications;/*data为ndataStruct类型的GHashTable*/
    GHashTable *blacklist_to_level;
    GSettings  *settings;
};

struct _CdosNotificationDaemonClass
{
    GObjectClass parent_class;
};

GType cdos_notification_daemon_get_type (void);

#endif //__CDOS_NOTIFICATION_DAEMON_H__
