
#ifndef __CDOS_OVERVIEW_WINDOW_CLONE_H__
#define __CDOS_OVERVIEW_WINDOW_CLONE_H__

#include <clutter/clutter.h>
#include <meta/window.h>
#include <meta/meta-window-actor.h>

#include "st.h"

#include "cdos-app.h"
#include "cdos-window-overlay.h"

/**
 * CdosFixedLayout: 修改ClutterFixedLayout
 */

#define CDOS_TYPE_FIXED_LAYOUT (cdos_fixed_layout_get_type ())
typedef struct _CdosFixedLayout CdosFixedLayout;
typedef struct _CdosFixedLayoutClass CdosFixedLayoutClass;

struct _CdosFixedLayout
{
    ClutterLayoutManager parent;
    ClutterActor *primary_actor;
};

struct _CdosFixedLayoutClass
{
    ClutterLayoutManagerClass parent_class;
};

GType cdos_fixed_layout_get_type (void);

ClutterLayoutManager *cdos_fixed_layout_new (ClutterActor *actor);


GType cdos_overview_window_clone_get_type (void);

#define CDOS_TYPE_OVERVIEW_WINDOW_CLONE (cdos_overview_window_clone_get_type())
#define CDOS_OVERVIEW_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_OVERVIEW_WINDOW_CLONE,CdosOverviewWindowClone))
#define CDOS_IS_OVERVIEW_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_OVERVIEW_WINDOW_CLONE))
#define CDOS_OVERVIEW_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_OVERVIEW_WINDOW_CLONE,CdosOverviewWindowCloneClass))
#define CDOS_IS_OVERVIEW_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_OVERVIEW_WINDOW_CLONE))
#define CDOS_OVERVIEW_WINDOW_CLONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_OVERVIEW_WINDOW_CLONE,CdosOverviewWindowCloneClass))


typedef struct _CdosOverviewWindowClone CdosOverviewWindowClone;
typedef struct _CdosOverviewWindowCloneClass CdosOverviewWindowCloneClass;

struct _CdosOverviewWindowClone
{
    ClutterActor parent;
    MetaWindowActor *realWindow;
    MetaWindow *metaWindow;
    CdosApp *app;
    ClutterActor *clone;
    ClutterActor *stackAbove;

    gboolean inDrag;

    gint urgencyTimeout;
    gboolean demanding_attention;

    guint positionChangedId;
    guint sizeChangedId;
    guint realWindowDestroyedId;
    guint workspaceChangedId;

    guint attentionId;
    guint urgentId;

    gfloat origX;
    gfloat origY;
};


struct _CdosOverviewWindowCloneClass
{
    ClutterActorClass parent_class;
};


//公有函数


CdosOverviewWindowClone *cdos_overview_window_clone_new (MetaWindowActor *windowActor);

void cdos_overview_window_clone_set_stack_above (CdosOverviewWindowClone *self, ClutterActor *actor);

#endif //__CDOS_OVERVIEW_WINDOW_CLONE_H__
