#ifndef __CDOS_PANEL_H__
#define __CDOS_PANEL_H__

#include "st.h"

#define CDOS_TYPE_PANEL                (cdos_panel_get_type ())
G_DECLARE_FINAL_TYPE (CdosPanel, cdos_panel, CDOS, PANEL, StWidget)

#define POPUP_MENU_DELAY 200
#define CHECK_MENU_OPEN_DELAY 400

CdosPanel * cdos_panel_new (gboolean bottom_position, gboolean is_primary);
ClutterActor * cdos_panel_get_leftbox (CdosPanel *panel);
ClutterActor * cdos_panel_get_centerbox (CdosPanel *panel);
ClutterActor * cdos_panel_get_rightbox (CdosPanel *panel);

void cdos_panel_enable (CdosPanel  *self, gint delay);
void cdos_panel_disable (CdosPanel *self, gint delay);
gboolean cdos_panel_get_hidden (CdosPanel  *self);

gboolean cdos_panel_get_bottom_position (CdosPanel *self);

void cdos_panel_set_bottom_position (CdosPanel    *self,
                                     gboolean bottom);
void cdos_panel_set_hideable (CdosPanel    *self,
                              gboolean hideable);
gboolean cdos_panel_get_hideable (CdosPanel *self);

gboolean cdos_panel_on_button_press (ClutterActor *actor,
		                             ClutterEvent *event,
                                     gpointer data);

void cdos_panel_set_height (CdosPanel *cdos_panel, gfloat height);
void cdos_panel_set_monitor (CdosPanel *cdos_panel, gint monitor);

gfloat cdos_panel_get_height (CdosPanel *cdos_panel);

void cdos_panel_add_launcher (CdosPanel *self,
                              const gchar *label,
                              const gchar *icon_name,
                              GCallback callback,
                              gint position,
                              gpointer user_data);

void cdos_panel_add_separator_item (CdosPanel *self);

typedef struct _CdosPopupBaseMenuItem CdosPopupBaseMenuItem;
void cdos_panel_add_menu_item (CdosPanel *self, CdosPopupBaseMenuItem *item);

#endif /* __CDOS_PANEL_H__ */
