#include <inttypes.h>

#ifndef __CDOS_PINYIN_H__
#define __CDOS_PINYIN_H__

/* 汉字转拼音，多音字每个拼音用-1分隔 */
int cdos_utf8_to_pinyin (const char *from, char **result);

const char *cdos_utf8_to_pinyin_fast (const char *from);

/*
 * 汉字与拼音匹配
 * source: 汉字序列
 * pattern: 字母序列或汉字
 * fuzzy: 是否模糊匹配，比如"yg"匹配“一个”
 */
int cdos_pinyin_match (const char *source, const char *pattern, int fuzzy);

int cdos_pinyin_compare (const char *s1, const char *s2);

#endif // __CDOS_PINYIN_H__
