#ifndef __POPUP_COMBO_MENU_H__
#define __POPUP_COMBO_MENU_H__

#include <glib-object.h>
#include <clutter/clutter.h>
#include "st.h"
#include "cdos-popup-menu-base.h"

GType
cdos_popup_combo_menu_get_type (void);

#define CDOS_TYPE_POPUP_COMBO_MENU            (cdos_popup_combo_menu_get_type ())

#define CDOS_POPUP_COMBO_MENU(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_POPUP_COMBO_MENU, CdosPopupComboMenu))

#define CDOS_IS_POPUP_COMBO_MENU(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_POPUP_COMBO_MENU))

#define CDOS_POPUP_COMBO_MENU_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_POPUP_COMBO_MENU, CdosPopupComboMenuClass))

#define CDOS_IS_POPUP_COMBO_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_POPUP_COMBO_MENU))

#define CDOS_POPUP_COMBO_MENU_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_POPUP_COMBO_MENU, CdosPopupComboMenuClass))

typedef struct _CdosPopupComboMenuPrivate CdosPopupComboMenuPrivate;
typedef struct _CdosPopupComboMenu        CdosPopupComboMenu;
typedef struct _CdosPopupComboMenuClass   CdosPopupComboMenuClass;

struct _CdosPopupComboMenu
{
  CdosPopupMenuBase          parent_instance;

  StBoxLayout               *actor;
  ClutterActor              *saved_focus_actor;
  CdosPopupComboMenuPrivate *priv;
};

struct _CdosPopupComboMenuClass
{
  CdosPopupMenuBaseClass parent_class;

  void (*clicked) (CdosPopupComboMenu *obj);
};

CdosPopupComboMenu *
cdos_popup_combo_menu_new (ClutterActor *source_actor);

const gchar *
cdos_popup_combo_menu_get_text (CdosPopupComboMenu *self);

void
cdos_popup_combo_menu_set_text (CdosPopupComboMenu *self, const gchar *text);

void
cdos_popup_combo_menu_open (CdosPopupMenuBase *self,gboolean animate);

void
cdos_popup_combo_menu_close (CdosPopupMenuBase *self,gboolean animate);

void
cdos_popup_combo_menu_set_active_item (CdosPopupComboMenu *self, gint position);

void
cdos_popup_combo_menu_set_item_visible (CdosPopupComboMenu *self, 
	                                gint                position,
				        gboolean            visible);

gpointer
cdos_popup_combo_menu_get_item_visible (CdosPopupComboMenu *self, gint position);

#endif
