#ifndef __CDOS_POPUP_IMAGE_MENU_ITEM_H__
#define __CDOS_POPUP_IMAGE_MENU_ITEM_H__

#include <st.h>
#include "cdos-popup-base-menu-item.h"

G_BEGIN_DECLS

#define CDOS_TYPE_POPUP_IMAGE_MENU_ITEM (cdos_popup_image_menu_item_get_type())

#define CDOS_POPUP_IMAGE_MENU_ITEM(obj)      \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_POPUP_IMAGE_MENU_ITEM, CdosPopupImageMenuItem))

#define CDOS_IS_POPUP_IMAGE_MENU_ITEM(obj)   \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_POPUP_IMAGE_MENU_ITEM))

#define CDOS_POPUP_IMAGE_MENU_ITEM_CLASS(klass)      \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_POPUP_IMAGE_MENU_ITEM, CdosPopupImageMenuItemClass))

#define CDOS_IS_POPUP_IMAGE_MENU_ITEM_CLASS(klass)   \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_POPUP_IMAGE_MENU_ITEM ))

#define CDOS_POPUP_IMAGE_MENU_ITEM_GET_CLASS(obj)    \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_POPUP_IMAGE_MENU_ITEM, CdosPopupImageMenuItemClass ))


typedef struct _CdosPopupImageMenuItem         CdosPopupImageMenuItem;
typedef struct _CdosPopupImageMenuItemPrivate  CdosPopupImageMenuItemPrivate;
typedef struct _CdosPopupImageMenuItemClass    CdosPopupImageMenuItemClass;

struct _CdosPopupImageMenuItem
{
	CdosPopupBaseMenuItem    parent_instance;
	CdosPopupImageMenuItemPrivate *priv;
};

struct  _CdosPopupImageMenuItemClass
{
	CdosPopupBaseMenuItemClass parent_class; 
};

GType  cdos_popup_image_menu_item_get_type(void) G_GNUC_CONST;

CdosPopupImageMenuItem *cdos_popup_image_menu_item_new (void);

CdosPopupImageMenuItem *cdos_popup_image_menu_item_new_with_params (const gchar *icon_name,const gchar *text);

void cdos_popup_image_menu_item_set_icon (CdosPopupImageMenuItem *item,
                                          const gchar *icon_name);

void 
cdos_popup_image_menu_item_set_label(CdosPopupImageMenuItem *item,
                                     const gchar *text);
void cdos_popup_image_menu_item_set_icon_by_gicon (CdosPopupImageMenuItem *item, const gchar *icon_name);


  #endif /*__CDOS_POPUP_IMAGE_MENU_ITEM_H__*/
