#ifndef __CDOS_POPUP_MENU_ITEM_H__
#define __CDOS_POPUP_MENU_ITEM_H__

#include "cdos-popup-base-menu-item.h"
#include "st.h"

G_BEGIN_DECLS

#define CDOS_TYPE_POPUP_MENU_ITEM (cdos_popup_menu_item_get_type())

#define CDOS_POPUP_MENU_ITEM(obj)  \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_POPUP_MENU_ITEM, CdosPopupMenuItem))

#define CDOS_IS_POPUP_MENU_ITEM(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_POPUP_MENU_ITEM))

#define CDOS_POPUP_MENU_ITEM_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_POPUP_MENU_ITEM, CdosPopupMenuItemClass))

#define CDOS_IS_POPUP_MENU_ITEM_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),  CDOS_TYPE_POPUP_MENU_ITEM ))

#define CDOS_POPUPMENUITEM_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_POPUP_MENU_ITEM, CdosPopupMenuItemClass ))

typedef struct _CdosPopupMenuItem             CdosPopupMenuItem;
typedef struct _CdosPopupMenuItemPrivate      CdosPopupMenuItemPrivate;
typedef struct _CdosPopupMenuItemClass          CdosPopupMenuItemClass;


struct _CdosPopupMenuItem
{
    CdosPopupBaseMenuItem parent_instance;

    CdosPopupMenuItemPrivate *priv;
};

struct _CdosPopupMenuItemClass
{
    CdosPopupBaseMenuItemClass parent_class;
};

GType cdos_popup_menu_item_get_type (void)  G_GNUC_CONST;

CdosPopupMenuItem *cdos_popup_menu_item_new (void); 

CdosPopupMenuItem *cdos_popup_menu_item_new_with_params (const gchar *text, PopupBaseMenuItemInit *params);

void cdos_popup_menu_item_set_label (CdosPopupMenuItem *item, const char *label);

void cdos_popup_menu_item_set_label_align (CdosPopupMenuItem *item, StAlign align, guint margin);

StLabel *cdos_popup_menu_item_get_label (CdosPopupMenuItem *item);

G_END_DECLS

#endif /*__CDOS_POPUP_MENU_ITEM_H__*/
