/*
 * cdos-popup-menu-manager.h
 *
 *  Created on: 2016年4月1日
 *      Author: wj
 */

#ifndef SRC_UI_CDOS_POPUP_MENU_MANAGER_H_
#define SRC_UI_CDOS_POPUP_MENU_MANAGER_H_

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include "cdos-global.h"
#include "cdos-popup-menu-base.h"

#define CDOS_TYPE_POPUP_MENU_MANAGER            (cdos_popup_menu_manager_get_type())

#define CDOS_POPUP_MENU_MANAGER(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_POPUP_MENU_MANAGER, CdosPopupMenuManager))

#define CDOS_IS_POPUP_MENU_MANAGER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_POPUP_MENU_MANAGER))

#define CDOS_POPUP_MENU_MANAGER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_POPUP_MENU_MANAGER, CdosPopupMenuManagerClass))

#define CDOS_IS_POPUP_MENU_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_POPUP_MENU_MANAGER))

#define CDOS_POPUP_MENU_MANAGER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_POPUP_MENU_MANAGER, CdosPopupMenuManagerClass))

typedef struct _CdosPopupMenuManagerPrivate CdosPopupMenuManagerPrivate;
typedef struct _CdosPopupMenuManager        CdosPopupMenuManager;
typedef struct _CdosPopupMenuManagerClass   CdosPopupMenuManagerClass;

struct _CdosPopupMenuManager
{
    GObject parent_instance;
    gboolean grabbed;
    CdosPopupMenuManagerPrivate *priv;
};

struct _CdosPopupMenuManagerClass
{
    GObjectClass parent_class;
};

GType cdos_popup_menu_manager_get_type(void) G_GNUC_CONST;

CdosPopupMenuManager *
cdos_popup_menu_manager_new (ClutterActor *owner);

ClutterActor *
cdos_popup_menu_manager_get_owner(CdosPopupMenuManager *self);

void
cdos_popup_menu_manager_set_owner(CdosPopupMenuManager *self, ClutterActor *owner);

void
cdos_popup_menu_manager_add_menu(CdosPopupMenuManager *self,
	                         CdosPopupMenuBase    *menu,
	                         gint                  position);

void
cdos_popup_menu_manager_remove_menu(CdosPopupMenuManager *self,
	                            CdosPopupMenuBase    *menu);

void
cdos_popup_menu_manager_set_event_capture(CdosPopupMenuManager *manager, 
	                                  gboolean (*fun )(ClutterActor *actor, 
	                                  ClutterEvent *event, 
	                                  gpointer user_data));
void cdos_popup_menu_manager_block_all_events (CdosPopupMenuManager *self,
                                               gboolean block_all_events);

#endif /* SRC_UI_CDOS_POPUP_MENU_MANAGER_H_ */
