#ifndef __POPUP_MENU_SECTION_H__
#define __POPUP_MENU_SECTION_H__

#include <glib.h>
#include "st.h"
#include "cdos-popup.h"

GType cdos_popup_menu_section_get_type (void);

#define CDOS_TYPE_POPUP_MENU_SECTION            (cdos_popup_menu_section_get_type ())

#define CDOS_POPUP_MENU_SECTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_POPUP_MENU_SECTION, CdosPopupMenuSection))

#define CDOS_IS_POPUP_MENU_SECTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_POPUP_MENU_SECTION))

#define CDOS_POPUP_MENU_SECTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_POPUP_MENU_SECTION, CdosPopupMenuSectionClass))

#define CDOS_IS_POPUP_MENU_SECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_POPUP_MENU_SECTION))

#define CDOS_POPUP_MENU_SECTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_POPUP_MENU_SECTION, CdosPopupMenuSectionClass))

typedef struct _CdosPopupMenuSectionPrivate CdosPopupMenuSectionPrivate;
typedef struct _CdosPopupMenuSection        CdosPopupMenuSection;
typedef struct _CdosPopupMenuSectionClass   CdosPopupMenuSectionClass;

struct _CdosPopupMenuSection
{
    CdosPopupMenuBase parent_instance;

    CdosPopupMenuSectionPrivate *priv;
};

struct _CdosPopupMenuSectionClass
{
    CdosPopupMenuBaseClass parent_class;

    void(*clicked) (CdosPopupMenuSection *obj);
};

CdosPopupMenuSection *cdos_popup_menu_section_new (void);

const gchar *cdos_popup_menu_section_get_text (CdosPopupMenuSection *self);

void cdos_popup_menu_section_set_text (CdosPopupMenuSection *self, const gchar *text);

void cdos_popup_menu_section_open (CdosPopupMenuBase *self, gboolean animate);

void cdos_popup_menu_section_close (CdosPopupMenuBase *self, gboolean animate);

#endif
