#ifndef __POPUP_MENU_H__
#define __POPUP_MENU_H__

#include <glib.h>
#include <gtk/gtk.h>
#include <clutter/clutter.h>
#include "st.h"
#include "cdos-box-pointer.h"
#include "cdos-popup-menu-base.h"

GType cdos_popup_menu_get_type (void) G_GNUC_CONST;

#define CDOS_TYPE_POPUP_MENU            (cdos_popup_menu_get_type ())

#define CDOS_POPUP_MENU(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_POPUP_MENU, CdosPopupMenu))

#define CDOS_IS_POPUP_MENU(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_POPUP_MENU))

#define CDOS_POPUP_MENU_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_POPUP_MENU, CdosPopupMenuClass))

#define CDOS_IS_POPUP_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_POPUP_MENU))

#define CDOS_POPUP_MENU_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_POPUP_MENU, CdosPopupMenuClass))

typedef struct _CdosPopupMenuPrivate CdosPopupMenuPrivate;
typedef struct _CdosPopupMenu        CdosPopupMenu;
typedef struct _CdosPopupMenuClass   CdosPopupMenuClass;

struct _CdosPopupMenu
{
    CdosPopupMenuBase     parent_instance;
    ClutterActor         *actor;
    CdosPopupMenuPrivate *priv;
};

struct _CdosPopupMenuClass
{
    CdosPopupMenuBaseClass parent_class;
};

gfloat cdos_popup_menu_get_arrow_alignment(CdosPopupMenu *self);

void cdos_popup_menu_set_arrow_alignment (CdosPopupMenu *self, gfloat alignment);

gint cdos_popup_menu_get_arrow_side (CdosPopupMenu *self);

void cdos_popup_menu_set_arrow_side (CdosPopupMenu *self, gint side);

CdosPopupMenu *cdos_popup_menu_new (ClutterActor *source);

CdosPopupMenu *
cdos_popup_menu_new_with_params (ClutterActor *source_actor, 
                                 gfloat arrow_alignment,
                                 gint arrow_side);

G_DEPRECATED void
cdos_popup_menu_constructor(CdosPopupMenu *menu,
			    ClutterActor *source_actor,
			    gfloat arrow_alignment,
			    gint arrow_side);

void
cdos_popup_menu_set_arrow_origin(CdosPopupMenu *self, guint origin);

void 
cdos_popup_menu_set_source_alignment (CdosPopupMenu *self, gfloat alignment);

void 
cdos_popup_menu_open (CdosPopupMenuBase *self, gboolean animate);

void
cdos_popup_menu_open_to_x_y (CdosPopupMenuBase *obj, gboolean animate, gfloat x, gfloat y);

void 
cdos_popup_menu_close (CdosPopupMenuBase *self, gboolean animate);

void 
cdos_popup_menu_set_max_height (CdosPopupMenu *self);

CdosBoxPointer *
cdos_popup_menu_get_box_pointer (CdosPopupMenu *menu);

#endif
