#ifndef __POPUP_SUB_MENU_H__
#define __POPUP_SUB_MENU_H__

#include <glib-object.h>
#include <clutter/clutter.h>
#include "st.h"
#include "cdos-popup-menu-base.h"

GType cdos_popup_sub_menu_get_type (void);

#define CDOS_TYPE_POPUP_SUB_MENU            (cdos_popup_sub_menu_get_type ())
#define CDOS_POPUP_SUB_MENU(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_POPUP_SUB_MENU, CdosPopupSubMenu))
#define CDOS_IS_POPUP_SUB_MENU(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_POPUP_SUB_MENU))
#define CDOS_POPUP_SUB_MENU_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_POPUP_SUB_MENU, CdosPopupSubMenuClass))
#define CDOS_IS_POPUP_SUB_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_POPUP_SUB_MENU))
#define CDOS_POPUP_SUB_MENU_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_POPUP_SUB_MENU, CdosPopupSubMenuClass))

typedef struct _CdosPopupSubMenuPrivate CdosPopupSubMenuPrivate;
typedef struct _CdosPopupSubMenu        CdosPopupSubMenu;
typedef struct _CdosPopupSubMenuClass   CdosPopupSubMenuClass;

struct _CdosPopupSubMenu
{
    CdosPopupMenuBase parent_instance;
    CdosPopupSubMenuPrivate *priv;
};

struct _CdosPopupSubMenuClass
{
    CdosPopupMenuBaseClass parent_class;
    void (* clicked)(CdosPopupSubMenu *obj);
};

CdosPopupSubMenu *
cdos_popup_sub_menu_new (ClutterActor *source_actor, ClutterActor *source_arrow);

CdosPopupMenuBase *
cdos_popup_sub_menu_get_top_menu(CdosPopupSubMenu *self);

void
cdos_popup_sub_menu_open(CdosPopupMenuBase *self, gboolean animate);

void
cdos_popup_sub_menu_close(CdosPopupMenuBase *self, gboolean animate);

#endif
