#ifndef __CDOS_POPUP_SUBMENU_MENU_ITEM_H__
#define __CDOS_POPUP_SUBMENU_MENU_ITEM_H__

#include <glib.h>
#include <glib-object.h>
#include "cdos-popup-menu-base.h"
#include "cdos-popup-menu.h"
#include "cdos-popup-base-menu-item.h"
#include "cdos-popup-sub-menu.h"

#define CDOS_TYPE_POPUP_SUBMENU_MENU_ITEM    \
        (cdos_popup_submenu_menu_item_get_type())

#define CDOS_POPUP_SUBMENU_MENU_ITEM(obj)    \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_POPUP_SUBMENU_MENU_ITEM, CdosPopupSubmenuMenuItem))

#define CDOS_IS_POPUP_SUBMENU_MENU_ITEM(obj)    \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_POPUP_SUBMENU_MENU_ITEM))

#define CDOS_POPUP_SUBMENU_MENU_ITEM_CLASS(klass)    \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_POPUP_SUBMENU_MENU_ITEM, CdosPopupSubmenuMenuItemClass))

#define CDOS_IS_POPUP_SUBMENU_MENU_ITEM_CLASS(klass)    \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_POPUP_SUBMENU_MENU_ITEM ))

#define CDOS_POPUP_SUBMENU_MENU_ITEM_GET_CLASS(obj)	    \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_POPUP_SUBMENU_MENU_ITEM, CdosPopupSubmenuMenuItemClass))

typedef struct _CdosPopupSubmenuMenuItem        CdosPopupSubmenuMenuItem;
typedef struct _CdosPopupSubmenuMenuItemPrivate CdosPopupSubmenuMenuItemPrivate;
typedef struct  _CdosPopupSubmenuMenuItemClass  CdosPopupSubmenuMenuItemClass;


struct _CdosPopupSubmenuMenuItem
{
	CdosPopupBaseMenuItem              parent_instance;
    CdosPopupSubMenu                  *menu;
	CdosPopupSubmenuMenuItemPrivate   *priv;
};

struct  _CdosPopupSubmenuMenuItemClass
{
	CdosPopupBaseMenuItemClass 	parent_class;
};

GType  cdos_popup_submenu_menu_item_get_type(void) G_GNUC_CONST;

CdosPopupSubmenuMenuItem *
cdos_popup_submenu_menu_item_new(const gchar *text, gboolean hide_expander);

CdosPopupSubMenu *
cdos_popup_submenu_menu_item_get_menu(CdosPopupSubmenuMenuItem *item);

#endif /*__CDOS_POPUP_SUBMENU_MENU_ITEM_H__*/
