#ifndef __CDOS_POPUP_SWITCH_MENU_ITEM_H__
#define __CDOS_POPUP_SWITCH_MENU_ITEM_H__

#include "st.h"
#include "cdos-popup-base-menu-item.h"

G_BEGIN_DECLS

#define CDOS_TYPE_POPUP_SWITCH_MENU_ITEM    \
        (cdos_popup_switch_menu_item_get_type())

#define CDOS_POPUP_SWITCH_MENU_ITEM(obj)    \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_POPUP_SWITCH_MENU_ITEM, CdosPopupSwitchMenuItem))

#define CDOS_IS_POPUP_SWITCH_MENU_ITEM(obj)    \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_POPUP_SWITCH_MENU_ITEM))

#define CDOS_POPUP_SWITCH_MENU_ITEM_CLASS(klass)    \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_POPUP_SWITCH_MENU_ITEM, CDOSPopupSwitchMenuItemClass)

#define CDOS_IS_POPUP_SWITCH_MENU_ITEM_CLASS(klass)    \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_POPUP_SWITCH_MENU_ITEM ))

#define CDOS_POPUP_SWITCH_MENU_ITEM_GET_CLASS(obj)    \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_POPUP_SWITCH_MENU_ITEM, CDOSPopupSwitchMenuItemClass ))

typedef struct _CdosPopupSwitchMenuItem          CdosPopupSwitchMenuItem;
typedef struct _CdosPopupSwitchMenuItemPrivate   CdosPopupSwitchMenuItemPrivate;
typedef struct _CdosPopupSwitchMenuItemClass     CdosPopupSwitchMenuItemClass;

struct _CdosPopupSwitchMenuItem
{
	CdosPopupBaseMenuItem           parent_instance;
	CdosPopupSwitchMenuItemPrivate *priv;
};

struct  _CdosPopupSwitchMenuItemClass
{
	CdosPopupBaseMenuItemClass parent_class; 
    void (*toggled) (CdosPopupSwitchMenuItem *item, gboolean state);
};

GType  cdos_popup_switch_menu_item_get_type(void) G_GNUC_CONST;

CdosPopupSwitchMenuItem  *
cdos_popup_switch_menu_item_new(void);

CdosPopupSwitchMenuItem *
cdos_popup_switch_menu_item_new_with_params(const gchar *text, gboolean  active, PopupBaseMenuItemInit *params);

void 
cdos_popup_switch_menu_item_set_status(CdosPopupSwitchMenuItem *item, const char *text);

void 
cdos_popup_switch_menu_item_activate(CdosPopupSwitchMenuItem *item, ClutterEvent *event,gboolean keep_menu);

void 
cdos_popup_switch_menu_item_toggle(CdosPopupSwitchMenuItem *item);

gboolean 
cdos_popup_switch_menu_item_get_status(CdosPopupSwitchMenuItem *item);

void 
cdos_popup_switch_menu_item_set_toggle_status(CdosPopupSwitchMenuItem *item, gboolean status);

void 
cdos_popup_switch_menu_item_set_active(CdosPopupSwitchMenuItem *item, gboolean active);

void 
cdos_popup_switch_menu_item_set_text(CdosPopupSwitchMenuItem *item, const gchar *text);

#endif /*__CDOS_POPUP_SWITCH_MENU_ITEM_H__*/
