/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *
 * This software is published by the license of CPU-OS License，you can use and
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us
 * by email <support_os@cpu-os.ac.cn>
 *
 **/
#ifndef __CDOS_POWER_DIALOG_H__
#define __CDOS_POWER_DIALOG_H__

#include <glib-object.h>
#include <gio/gio.h>

#include "st.h"

GType cdos_power_dialog_get_type (void);

#define CDOS_TYPE_POWER_DIALOG (cdos_power_dialog_get_type ())
#define CDOS_POWER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_POWER_DIALOG, CdosPowerDialog))
#define CDOS_IS_POWER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_POWER_DIALOG))
#define CDOS_POWER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_POWER_DIALOG, CdosPowerDialogClass))
#define CDOS_IS_POWER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_POWER_DIALOG))
#define CDOS_POWER_DIALOG_GET_CLASS(obj)                                                                               \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_POWER_DIALOG, CdosPowerDialogClass))

typedef struct _CdosPowerDialog CdosPowerDialog;
typedef struct _CdosPowerDialogClass CdosPowerDialogClass;

struct _CdosPowerDialogClass
{
    StWidgetClass parent_class;
};

typedef enum
{
    PA_NONE,
    PA_SWITCH_USER,
    PA_SUSPEND,
    PA_HIBERNATE,
    PA_SCREENSAVER_LOCK,
    PA_LOGOUT,
    PA_REBOOT,
    PA_POWER_OFF,
} PowerActionId;

CdosPowerDialog *
cdos_power_dialog_new (void);
CdosPowerDialog *
cdos_power_dialog_get (void);
gboolean
cdos_power_dialog_run (PowerActionId action_id);


#endif
