/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *
 * This software is published by the license of CPU-OS License，you can use and
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us
 * by email <support_os@cpu-os.ac.cn>
 *
 **/
#ifndef __CDOS_PROGRESS_BAR_H__
#define __CDOS_PROGRESS_BAR_H__

#include <glib.h>
#include <clutter/clutter.h>
#include "st.h"

G_BEGIN_DECLS

#define CDOS_TYPE_PROGRESS_BAR (cdos_progress_bar_get_type ())
#define CDOS_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_PROGRESS_BAR, CdosProgressBar))
#define CDOS_IS_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_PROGRESS_BAR))
#define CDOS_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((obj), CDOS_TYPE_PROGRESS_BAR, CdosProgressBarClass))
#define CDOS_PROGRESS_BAR_GET_CLASS(obj)                                                                               \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_PROGRESS_BAR, CdosProgressBarClass))

typedef struct _CdosProgressBar CdosProgressBar;
typedef struct _CdosProgressBarPrivate CdosProgressBarPrivate;
typedef struct _CdosProgressBarClass CdosProgressBarClass;

struct _CdosProgressBar
{
    StWidget parent_instance;
    CdosProgressBarPrivate *priv;
};

struct _CdosProgressBarClass
{
    StWidgetClass parent_class;
};

GType cdos_progress_bar_get_type (void);

void cdos_progress_bar_set_fraction (CdosProgressBar *self, gfloat value);

gfloat cdos_progress_bar_get_fraction (CdosProgressBar *self);

void cdos_progress_bar_set_direction (CdosProgressBar *self, ClutterTextDirection direction);

void cdos_progress_bar_add_markup (CdosProgressBar *self, gfloat value, const gchar *markup);

void cdos_progress_bar_clear_markups (CdosProgressBar *self);

void cdos_progress_bar_set_pulse_step (CdosProgressBar *self, gfloat pulse_step);

CdosProgressBar *cdos_progress_bar_new (void);

G_END_DECLS

#endif // __CDOS_PROGRESS_BAR_H__
