#ifndef __CDOS_SCALE_H__
#define __CDOS_SCALE_H__

#include <glib.h>
#include <clutter/clutter.h>
#include "st.h"

G_BEGIN_DECLS

#define CDOS_TYPE_SCALE (cdos_scale_get_type ())
#define CDOS_SCALE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_SCALE, CdosScale))
#define CDOS_IS_SCALE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_SCALE))
#define CDOS_SCALE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((obj), CDOS_TYPE_SCALE, CdosScaleClass))
#define CDOS_SCALE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_SCALE, CdosScaleClass))

typedef struct _CdosScale CdosScale;
typedef struct _CdosScalePrivate CdosScalePrivate;
typedef struct _CdosScaleClass CdosScaleClass;

struct _CdosScale
{
    StWidget parent_instance;
    CdosScalePrivate *priv;
};

struct _CdosScaleClass
{
    StWidgetClass parent_class;
};

GType cdos_scale_get_type (void);

void cdos_scale_set_value (CdosScale *self, gfloat value);

gfloat cdos_scale_get_value (CdosScale *self);

void cdos_scale_set_direction (CdosScale *self, ClutterTextDirection direction);

void cdos_scale_increment (CdosScale *self);

void cdos_scale_decrement (CdosScale *self);

void cdos_scale_add_markup (CdosScale *self, gfloat value, const gchar *markup);

void cdos_scale_clear_markups (CdosScale *self);

void cdos_scale_set_range (CdosScale *self, gfloat min, gfloat max, gfloat step);

CdosScale *cdos_scale_new (void);

CdosScale *cdos_scale_new_with_range (ClutterOrientation orientation, gfloat min, gfloat max, gfloat step);

G_END_DECLS

#endif // __CDOS_SCALE_H__
