/**
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *
 * This software is published by the license of CPU-OS License，you can use and
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us
 * by email <support_os@cpu-os.ac.cn>
 *
 **/
#ifndef __CDOS_SCREEN_SAVER_H__
#define __CDOS_SCREEN_SAVER_H__

#include <glib-object.h>
#include <gio/gio.h>

#include "st.h"

GType cdos_screen_saver_get_type (void);

#define CDOS_TYPE_SCREEN_SAVER (cdos_screen_saver_get_type ())
#define CDOS_SCREEN_SAVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_SCREEN_SAVER, CdosScreenSaver))
#define CDOS_IS_SCREEN_SAVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_SCREEN_SAVER))
#define CDOS_SCREEN_SAVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_SCREEN_SAVER, CdosScreenSaverClass))
#define CDOS_IS_SCREEN_SAVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_SCREEN_SAVER))
#define CDOS_SCREEN_SAVER_GET_CLASS(obj)                                                                               \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_SCREEN_SAVER, CdosScreenSaverClass))

typedef struct _CdosScreenSaver CdosScreenSaver;
typedef struct _CdosScreenSaverClass CdosScreenSaverClass;

struct _CdosScreenSaverClass
{
    StWidgetClass parent_class;
};

CdosScreenSaver *cdos_screen_saver_new (void);

CdosScreenSaver *cdos_screen_saver_get (void);

void cdos_screen_saver_lock (void);

gboolean cdos_screen_saver_get_active (void);

#endif
