/*
*
* This program is free software; you can redistribute it and/or modify it
* under the terms and conditions of the GNU Lesser General Public License,
* version 2.1, as published by the Free Software Foundation.
* 
* This program is distributed in the hope it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
* more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __CDOS_SEARCH_PROVIDER_H__
#define __CDOS_SEARCH_PROVIDER_H__

#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

typedef struct _CdosSearchResult
{
    char *name;
    GIcon *icon;
    char *description;
    char *path;
}CdosSearchResult;

void cdos_search_results_free (GPtrArray *results);


#define CDOS_TYPE_SEARCH_PROVIDER (cdos_search_provider_get_type ())

G_DECLARE_DERIVABLE_TYPE (CdosSearchProvider, cdos_search_provider, CDOS, SEARCH_PROVIDER, GObject)

struct _CdosSearchProviderClass
{
    GObjectClass parent_class;
    void (*search) (CdosSearchProvider *self, const gchar *str, gint count);
    void (*cancel) (CdosSearchProvider *self);
};

CdosSearchProvider *cdos_search_provider_new (void);

void cdos_search_provider_search (CdosSearchProvider *self, const char *str, gint count);

void cdos_search_provider_cancel (CdosSearchProvider *self);

#endif // __CDOS_SEARCH_PLOCATE_H__
