#ifndef __CDOS_SESSION_H__
#define __CDOS_SESSION_H__

#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

typedef enum
{
    GSM_INHIBITOR_FLAG_LOGOUT      = 1 << 0,
    GSM_INHIBITOR_FLAG_SWITCH_USER = 1 << 1,
    GSM_INHIBITOR_FLAG_SUSPEND     = 1 << 2,
    GSM_INHIBITOR_FLAG_IDLE        = 1 << 3,
    GSM_INHIBITOR_FLAG_AUTOMOUNT   = 1 << 4
} GsmInhibitorFlag;

/* Presence */
#define CDOS_TYPE_SESSION_PRESENCE (cdos_session_presence_get_type ())
G_DECLARE_FINAL_TYPE (CdosSessionPresence, cdos_session_presence, CDOS, SESSION_PRESENCE, GObject)

enum
{
    CDOS_SESSION_AVAILABLE = 0,
    CDOS_SESSION_INVISIBLE,
    CDOS_SESSION_BUSY,
    CDOS_SESSION_IDLE
};

CdosSessionPresence *cdos_session_presence_new (void);
guint cdos_session_presence_get_status (CdosSessionPresence *presence, GFunc callback);
gboolean cdos_session_presence_set_status (CdosSessionPresence *presence, guint status);


/* Inhibitor */
#define CDOS_TYPE_SESSION_INHIBITOR (cdos_session_inhibitor_get_type ())
G_DECLARE_FINAL_TYPE (CdosSessionInhibitor, cdos_session_inhibitor, CDOS, SESSION_INHIBITOR, GObject)

CdosSessionInhibitor *
cdos_session_inhibitor_new (gchar *object_path);
gchar *
cdos_session_inhibitor_get_app_id (CdosSessionInhibitor *self);
gchar *
cdos_session_inhibitor_get_reason (CdosSessionInhibitor *self);

/* session */
#define CDOS_TYPE_SESSION_MANAGER (cdos_session_manager_get_type ())
G_DECLARE_FINAL_TYPE (CdosSessionManager, cdos_session_manager, CDOS, SESSION_MANAGER, GObject)

CdosSessionManager *cdos_session_new (void);
void 
cdos_session_logout (guint mode);
void 
cdos_session_shutdown (void);
gboolean 
cdos_session_can_shutdown (void);
void 
cdos_session_reboot (void);
char **
cdos_session_get_inhibitors (void);
guint32 
cdos_session_get_inhibited_actions (void);
void
cdos_session_suspend (void);
void 
cdos_session_hibernate (void);

G_END_DECLS

#endif
