#ifndef __CDOS_SYSTRAY_MANAGER_H__
#define __CDOS_SYSTRAY_MANAGER_H__

#include <glib-object.h>
#include <gio/gio.h>

#define CDOS_TYPE_SYSTRAY_MANAGER (cdos_systray_manager_get_type ())

#define CDOS_SYSTRAY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_SYSTRAY_MANAGER, CdosSystrayManager))

#define CDOS_IS_SYSTRAY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_SYSTRAY_MANAGER))

#define CDOS_SYSTRAY_MANAGER_CLASS(klass)                                                                              \
    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_SYSTRAY_MANAGER, CdosSystrayManagerClass))

#define CDOS_IS_SYSTRAY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_SYSTRAY_MANAGER))

#define CDOS_SYSTRAY_MANAGER_GET_CLASS(obj)                                                                            \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_SYSTRAY_MANAGER, CdosSystrayManagerClass))


typedef struct _CdosSystrayManager CdosSystrayManager;
typedef struct _CdosSystrayManagerClass CdosSystrayManagerClass;

/* instance structure */
struct _CdosSystrayManager
{
    /*父类*/
    GObject parent_instance;

    GList *roles;
};
/* class structure */
struct _CdosSystrayManagerClass
{
    /*父类*/
    GObjectClass parent_class;

    /*信号*/
    void (*systray_changed) (CdosSystrayManager *self);

    /*私有变量*/
};

GType cdos_systray_manager_get_type (void);

void cdos_systray_manager_register_role (CdosSystrayManager *self, const gchar *role, const gchar *id);
void cdos_systray_manager_unregister_role (CdosSystrayManager *self, const gchar *role, const gchar *id);
void cdos_systray_manager_unregister_id (CdosSystrayManager *self, const gchar *id);
GList *cdos_systray_manager_get_roles (CdosSystrayManager *self, const gchar *id);

CdosSystrayManager *cdos_systray_manager_new (void);
#endif
