#ifndef __CDOS_TEXT_ICON_APPLET_H__
#define __CDOS_TEXT_ICON_APPLET_H__

#include "cdos-icon-applet.h"

/**
 * Applet that displays an icon and a text. The icon is on the left of the text.
 * Inherits: CDOS_ICON_APPLET (CdosIconApplet)
 */

GType cdos_text_icon_applet_get_type(void);

#define CDOS_TYPE_TEXT_ICON_APPLET	(cdos_text_icon_applet_get_type ())
#define CDOS_TEXT_ICON_APPLET(obj)	(G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_TEXT_ICON_APPLET, CdosTextIconApplet))
#define CDOS_IS_TEXT_ICON_APPLET(obj)	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_TEXT_ICON_APPLET))
#define CDOS_TEXT_ICON_APPLET_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_TEXT_ICON_APPLET, CdosTextIconAppletClass))
#define CDOS_IS_TEXT_ICON_APPLET_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_TEXT_ICON_APPLET))
#define CDOS_TEXT_ICON_APPLET_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_TEXT_ICON_APPLET, CdosTextIconAppletClass))

typedef struct _CdosTextIconApplet	CdosTextIconApplet;
typedef struct _CdosTextIconAppletClass	CdosTextIconAppletClass;

struct _CdosTextIconApplet
{
    CdosIconApplet parent_instance;

    /* applet_label (ST_LABEL (StLabel)): Label of the applet */
    StLabel *applet_label;
};

struct _CdosTextIconAppletClass
{
    CdosIconAppletClass parent_class;
};

void cdos_text_icon_applet_hide_applet_icon (CdosTextIconApplet *text_icon_applet);

void cdos_text_icon_applet_set_applet_label (CdosTextIconApplet *text_icon_applet, const gchar *text);

CdosTextIconApplet *cdos_text_icon_applet_new (guint orientation, gfloat panel_height, const gchar *instance_id);

#endif /* __CDOS_TEXT_ICON_APPLET_H__ */
