/*
 * Author:
 *   leit <leitong@cpu-os.ac.cn>
 *
 * Created:
 *   2019年02月18日 10时19分44秒
 */

#ifndef __CDOS_TILE_PREVIEW_H__
#define __CDOS_TILE_PREVIEW_H__

#include "st.h"
#include <meta/window.h>
#include <meta/boxes.h>

GType cdos_tile_preview_get_type (void);

#define CDOS_TYPE_TILE_PREVIEW (cdos_tile_preview_get_type ())
#define CDOS_TILE_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_TILE_PREVIEW, CdosTilePreview))
#define CDOS_IS_TILE_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_TILE_PREVIEW))
#define CDOS_TILE_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_TILE_PREVIEW, CdosTilePreviewClass))
#define CDOS_IS_TILE_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((obj), CDOS_TYPE_TILE_PREVIEW))
#define CDOS_TILE_PREVIEW_GET_CLASS(obj)                                                                               \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_TILE_PREVIEW, CdosTilePreviewClass))


typedef struct _CdosTilePreview CdosTilePreview;
typedef struct _CdosTilePreviewClass CdosTilePreviewClass;
typedef struct _CdosTilePreviewPrivate CdosTilePreviewPrivate;

struct _CdosTilePreview
{
    StWidget parent;
    CdosTilePreviewPrivate *priv;
};

struct _CdosTilePreviewClass
{
    StWidgetClass parent_class;
};

ClutterActor *cdos_tile_preview_new (void);

void cdos_tile_preview_show (CdosTilePreview *preview, MetaWindow *window, MetaRectangle *rect, gint monitor);
void cdos_tile_preview_hide (CdosTilePreview *preview);

#endif /* __CDOS_TILE_PREVIEW_H__ */
