
#ifndef __CDOS_TOOLTIP_H__
#define __CDOS_TOOLTIP_H__

#include <glib-object.h>
#include "st.h"

#define cdos_tooltip_set_text(tooltip, text) st_label_set_text ((StLabel *)(tooltip), text)
GType cdos_tooltip_get_type (void);

#define CDOS_TYPE_TOOLTIP (cdos_tooltip_get_type ())
#define CDOS_TOOLTIP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_TOOLTIP, CdosTooltip))
#define CDOS_IS_TOOLTIP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_TOOLTIP))
#define CDOS_TOOLTIP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_TOOLTIP, CdosTooltipClass))
#define CDOS_IS_TOOLTIP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((obj), CDOS_TYPE_TOOLTIP))
#define CDOS_TOOLTIP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_TOOLTIP, CdosTooltipClass))


typedef struct _CdosTooltip CdosTooltip;
typedef struct _CdosTooltipClass CdosTooltipClass;
typedef struct _CdosTooltipPrivate CdosTooltipPrivate;


struct _CdosTooltip
{
    StLabel parent;
    CdosTooltipPrivate *priv;
    gfloat mousePositionX;
    gfloat mousePositionY;
    gboolean visible;
    gboolean preventShow;
    ClutterActor *item;
};

struct _CdosTooltipClass
{
    StLabelClass parent_class;
    void (*show) (CdosTooltip *self);
    void (*set_position) (CdosTooltip *self);
};

//公有函数

CdosTooltip *cdos_tooltip_new (ClutterActor *item, const gchar *init_title);

void cdos_tooltip_show (CdosTooltip *self);

void cdos_tooltip_hide (CdosTooltip *self);

void cdos_tooltip_set_prevent_show (CdosTooltip *self, gboolean prevent_show);

void cdos_tooltip_set_position (CdosTooltip *self, gfloat px, gfloat py);


#endif //__CDOS_TOOLTIP_H__
