#ifndef __CDOS_TRANSITION_H__
#define __CDOS_TRANSITION_H__

#include <clutter/clutter.h>

/* clutter 动画 api 封装 */
typedef void (*TransCallback) (ClutterTimeline *tml, void *data);
enum TransPropType
{
    TRANS_PROP_CHAR,
    TRANS_PROP_UCHAR,
    TRANS_PROP_INT,
    TRANS_PROP_UINT,
    TRANS_PROP_FLOAT,
    TRANS_PROP_DOUBLE
};

ClutterTransition *cdos_transition_to (ClutterActor *actor,
                                       ClutterAnimationMode mode,
                                       guint duration,
                                       guint repeat_count,
                                       TransCallback callback,
                                       void *data,
                                       const char *name,
                                       const char *first_property_name,
                                       ...) G_GNUC_NULL_TERMINATED;

ClutterTransition *cdos_transition_simple (ClutterActor *actor,
                                           ClutterAnimationMode mode,
                                           guint duration,
                                           const char *first_property_name,
                                           ...) G_GNUC_NULL_TERMINATED;

#endif /* __CDOS_TRANSITION_H__ */
