/**
 * created by lyl
 * Date: 2016-03-10
 */
#include "cdos-ui-plugin.h"

typedef struct _CdosUIPlugin
{
    ClutterActor *ui_group;

    CdosPanel *panel;
    StWidget  *dock;

    CdosBaseWM *cdos_base_wm;
    GSettings *settings;

    gchar *desktop_layout;
    StSide applet_side;

    CdosIconDispatcher *status_icon_dispatcher;

    CdosSystrayManager *systray_manager;

    CdosKeyboard *keyboard;
}CdosUIPlugin;

static CdosUIPlugin *cdos_ui_plugin = NULL;

static CdosUIPlugin *
cdos_ui_plugin_get (void)
{
    if (cdos_ui_plugin == NULL)
    {
        cdos_ui_plugin = g_new0 (CdosUIPlugin, 1);
    }
    return cdos_ui_plugin;
}

ClutterActor *
cdos_ui_plugin_get_ui_group (void)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    return plugin->ui_group;
}

void
cdos_ui_plugin_set_ui_group (ClutterActor *ui_group)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    plugin->ui_group = ui_group;
}

CdosPanel *
cdos_ui_plugin_get_panel (void)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    return plugin->panel;
}

StWidget *
cdos_ui_plugin_get_dock (void)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    return plugin->dock;
}

void
cdos_ui_plugin_set_panel (CdosPanel *panel)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    plugin->panel = panel;
}

void
cdos_ui_plugin_set_dock (StWidget *dock)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    plugin->dock = dock;
}

CdosBaseWM *
cdos_ui_plugin_get_cdos_base_wm (void)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    return plugin->cdos_base_wm;
}

void
cdos_ui_plugin_set_cdos_base_wm (CdosBaseWM *cdos_base_wm)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    plugin->cdos_base_wm = cdos_base_wm;
}

void
cdos_ui_plugin_set_desktop_layout (const gchar *desktop_layout)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    plugin->desktop_layout = g_strdup (desktop_layout);
}

void
cdos_ui_plugin_set_applet_side (StSide applet_side)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    plugin->applet_side = applet_side;
}

StSide
cdos_ui_plugin_get_applet_side (void)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    return plugin->applet_side;
}

CdosIconDispatcher *
cdos_ui_plugin_get_status_icon_dispatcher (void)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    return plugin->status_icon_dispatcher;
}

void
cdos_ui_plugin_set_status_icon_dispatcher (CdosIconDispatcher *icon_dispatcher)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    plugin->status_icon_dispatcher = icon_dispatcher;
}

CdosSystrayManager *
cdos_ui_plugin_get_systray_manager (void)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    return plugin->systray_manager;
}

void
cdos_ui_plugin_set_systray_manager (CdosSystrayManager *systray_manager)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    plugin->systray_manager = systray_manager;
}

CdosKeyboard *
cdos_ui_plugin_get_keyboard (void)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    return plugin->keyboard;
}

gboolean
cdos_ui_plugin_set_keyboard (CdosKeyboard *keyboard)
{
    CdosUIPlugin *plugin = cdos_ui_plugin_get ();
    plugin->keyboard = keyboard;
    return TRUE;
}
