/** 
 * Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
 *  
 * This software is published by the license of CPU-OS License，you can use and 
 * distibuted this software under this License. See CPU-OS Liense for more detail.
 *
 * You should have receive a copy of CPU-OS License. If not, please contact us 
 * by email <support_os@cpu-os.ac.cn>  
 * 
 **/
#ifndef __CDOS_URL_HIGHLIGHTER_H__
#define __CDOS_URL_HIGHLIGHTER_H__

/**
 * 用于对通知的URL进行高亮显示
 * Inherits: #GObject
 */

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <st.h>
#include <cdos-util.h>

#define CDOS_TYPE_URL_HIGHLIGHTER (cdos_url_highlighter_get_type())
#define CDOS_URL_HIGHLIGHTER(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_URL_HIGHLIGHTER,CdosUrlHighlighter))
#define CDOS_IS_URL_HIGHLIGHTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_URL_HIGHLIGHTER))
#define CDOS_URL_HIGHLIGHTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_URL_HIGHLIGHTER,CdosUrlHighlighterClass))
#define CDOS_IS_URL_HIGHLIGHTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_URL_HIGHLIGHTER))
#define CDOS_URL_HIGHLIGHTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_URL_HIGHLIGHTER,CdosUrlHighlighterClass))

typedef struct _CdosUrlHighlighter CdosUrlHighlighter;
typedef struct _CdosUrlHighlighterClass CdosUrlHighlighterClass;

struct _CdosUrlHighlighter
{
    StLabel parent_instance;

    gchar *text;
    gchar *link_color;
    gchar *url; //不确定
    GList *urls;
    gboolean cursor_changed;

};

struct _CdosUrlHighlighterClass
{
    StLabelClass parent_class;
};

GType cdos_url_highlighter_get_type (void);

void cdos_url_highlighter_set_markup (CdosUrlHighlighter *self, const gchar *text);

gchar *cdos_url_highlighter_fix_markup (const gchar *text);

StLabel *cdos_url_highlighter_new (const gchar *text, gboolean line_wrap);

#endif
