/*
 * Copyright 2016 zhangtao.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU Lesser General Public License,
 * version 2.1, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
 * more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __CDOS_WINDOW_CLONE_H__
#define __CDOS_WINDOW_CLONE_H__

#include <meta/window.h>
#include <meta/meta-window-actor.h>
#include "st.h"

#include "cdos-workspace.h"

#define CDOS_TYPE_WINDOW_CLONE (cdos_window_clone_get_type())

G_DECLARE_FINAL_TYPE (CdosWindowClone, cdos_window_clone, CDOS, WINDOW_CLONE, StWidget)

CdosWindowClone *cdos_window_clone_new (MetaWindowActor *real_window);

void cdos_window_clone_set_stack_above (CdosWindowClone *self, ClutterActor *actor);

void cdos_window_clone_hide_overlay (CdosWindowClone *self, gboolean animate);

void cdos_window_clone_chrome_heights (CdosWindowClone *self,
                                       gfloat *top_over_size,
                                       gfloat *bottom_over_size);

void cdos_window_clone_chrome_widths (CdosWindowClone *self,
                                      gfloat *left_over_size,
                                      gfloat *right_over_size);

#endif //__CDOS_WINDOW_CLONE_H__
